SystemOrganization addCategory: #'TF-Login'!

WAEmailMessage subclass: #TLWAEmailMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TF-Login'!

!TLWAEmailMessage commentStamp: '<historical>' prior: 0!
I am a stand-in for WAEmailMessage supporting multi-part MIME messages until Seaside can take advantage of Pharo issue 3509 (Multi-part MIME support for MailMessage).!

!TLWAEmailMessage methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/6/2011 12:29'!
plainMessage
	^ String streamContents: 
		[ :stream | 
		self 
			renderAddress: self from
			withHeader: 'From: '
			on: stream.
		self to do: 
			[ :each | 
			self 
				renderAddress: each
				withHeader: 'To: '
				on: stream ].
		self cc do: 
			[ :each | 
			self 
				renderAddress: each
				withHeader: 'Cc: '
				on: stream ].
		self bcc do: 
			[ :each | 
			self 
				renderAddress: each
				withHeader: 'Bcc: '
				on: stream ].
		stream
			nextPutAll: 'Subject: ';
			nextPutAll: self subject;
			nextPut: Character cr.

		self headers keysAndValuesDo:
			[:k : v |
				stream
					nextPutAll: k;
					nextPutAll: ': ';
					nextPutAll: v;
					nextPut: Character cr ].

		stream	
			nextPut: Character cr.
		self body isNil ifFalse: [ stream nextPutAll: self body greaseString ] ]! !

OrderedCollection subclass: #TLTestAppLoginHistoryList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TF-Login'!

!TLTestAppLoginHistoryList methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/16/2010 08:48'!
asString

	| stream |
	stream := WriteStream on: String new.
	self do: [ :each |
		stream
			nextPutAll: each asString;
			nextPutAll: ', '.
		].
	^ stream contents allButLast: 2! !

MailMessage subclass: #TLMailMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TF-Login'!

!TLMailMessage commentStamp: '<historical>' prior: 0!
I am a stand-in for MailMessage to add multi-part MIME support until issue 3509 (Multi-part MIME support for MailMessage) is incuded in Pharo.!

!TLMailMessage methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/6/2011 12:25'!
addAlternativePart: newPart
	self makeMultipart: 'alternative' with: newPart.
! !

!TLMailMessage methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/6/2011 12:25'!
addAlternativePart: bodyString contentType: aContentTypeString

	| newPart |
	newPart := MailMessage empty.
	newPart setField: 'content-type' toString: aContentTypeString.
	newPart body: (MIMEDocument contentType: aContentTypeString  content: bodyString).
	self addAlternativePart: newPart.
! !

!TLMailMessage methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/6/2011 12:25'!
addMixedPart: newPart
	self makeMultipart: 'mixed' with: newPart.
! !

!TLMailMessage methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/6/2011 12:26'!
addMixedPart: bodyString contentType: aContentTypeString

	| newPart |
	newPart := MailMessage empty.
	newPart setField: 'content-type' toString: aContentTypeString.
	newPart body: (MIMEDocument contentType: aContentTypeString  content: bodyString).
	self addMixedPart: newPart.
! !

!TLMailMessage methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/6/2011 12:26'!
addPart: bodyString contentType: aContentTypeString

	| newPart |
	newPart := MailMessage empty.
	newPart setField: 'content-type' toString: aContentTypeString.
	newPart body: (MIMEDocument contentType: aContentTypeString  content: bodyString).
	self addPart: newPart.
! !

!TLMailMessage methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/6/2011 12:26'!
makeMultipart: subType with: newPart
	"if I am not multipart already, then become a multipart message with one part"

	| multipartHeader |

	body isMultipart
		ifFalse: [
			parts := Array with: newPart.

			"fix up our header"
			multipartHeader := MIMEHeaderValue fromMIMEHeader: 'multipart/',subType.
			multipartHeader parameterAt: 'boundary' put: self class generateSeparator .
			self setField: 'content-type' to: multipartHeader.

			self setField: 'mime-version' to: (MIMEHeaderValue fromMIMEHeader: '1.0').
			self removeFieldNamed: 'content-transfer-encoding']
		ifTrue: [
			self parts.
			parts := parts copyWith: newPart.
			].

	"regenerate everything"
	self regenerateBodyFromParts.
	text := nil.! !

!TLMailMessage methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/9/2011 12:06'!
seasideMailMessageFrom: fromAddress to: toAddress subject: mailSubject
	| msg waFields |
	
	waFields := #( 'from' 'to' 'date' 'subject').
	
	msg := TLWAEmailMessage from: (WAEmailAddress address: fromAddress)  to: (WAEmailAddress address: toAddress)  subject: mailSubject. 
	self fields keysAndValuesDo: [ :k :v |
		(waFields includes: k asLowercase) ifFalse: [
			msg headerAt: k put: v first asHeaderValue  ] ].
	msg body: self bodyText.
	^ msg! !

!GRPlatform methodsFor: '*TF-Login-seaside-override' stamp: 'TonyFleig 12/29/2010 18:40'!
seasideApplicationPreferenceAt: aKey ifAbsent: aBlock
		
	^ [WACurrentRequestContext value application preferenceAt: aKey] "in a Seaside context"
		"on: WARequestContextNotFound, WAAttributeNotFound"
		on: Exception 
		do: [:ex | aBlock value] "not in a Seaside context, treat as absent"! !

WAComponent subclass: #TLAccountChangeSubmitFailed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TF-Login'!

!TLAccountChangeSubmitFailed methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/2/2011 19:37'!
renderContentOn: html

	html form
		class: 'acctchangesubmitfailed';
		with: [ 
			html text: 'We failed trying to send your change confirmation email. The changes will not be made.';
				break.
			html button
				callback: [ self answer ];
				with: 'Ok']! !

WAComponent subclass: #TLAccountChangeSubmitted
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TF-Login'!

!TLAccountChangeSubmitted methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/2/2011 19:37'!
renderContentOn: html

	html form
		class: 'acctchangesubmitted';
		with: [ 
			html text: 'An email has been sent to the email address you povided that will allow you to confirm your account changes.';
				break.
			html button
				callback: [ self answer ];
				with: 'Ok']! !

WAComponent subclass: #TLEditAccountComponent
	instanceVariableNames: 'newEmail newPassword newPasswordConfirm currentPassword emailChangeConfirmationEmailSender newUsername accountChangeConfirmationEmailSender emailResult loginComponent accountChangeSubmitFailedComponent accountChangeSubmittedComponent newPasswordMismatch usernameExists passwordIsInvalid passwordValidationError'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TF-Login'!

!TLEditAccountComponent class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 06:33'!
loginComponent: aLoginComponent
	^ (self basicNew)
		initialize;
		loginComponent: aLoginComponent;
		yourself! !

!TLEditAccountComponent class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 06:33'!
new
	^ self shouldNotImplement ! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/3/2011 16:15'!
accountChangeConfirmationEmailSender
	^ accountChangeConfirmationEmailSender
	! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/3/2011 16:17'!
accountChangeConfirmationEmailSender: aFourArgBlock
	accountChangeConfirmationEmailSender := aFourArgBlock
	! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/2/2011 19:49'!
accountChangeSubmitFailedComponent
	^ accountChangeSubmitFailedComponent ifNil: [self defaultAccountChangeSubmitFailedComponent]! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/2/2011 19:47'!
accountChangeSubmitFailedComponent: aWAComponent
	accountChangeSubmitFailedComponent := aWAComponent ! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/2/2011 19:59'!
accountChangeSubmittedComponent
	^ accountChangeSubmittedComponent ifNil: [self defaultAccountChangeSubmittedComponent]! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/2/2011 19:48'!
accountChangeSubmittedComponent: aWAComponent
	accountChangeSubmittedComponent := aWAComponent ! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/26/2010 13:57'!
allowEmptyPassword
	^ self application preferenceAt: #allowEmptyPasswords ! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/26/2010 13:57'!
allowUsernameChange 
	^ self application preferenceAt: #allowUsernameChange ! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/3/2011 07:57'!
cancel
	self
		reset;
		answer ! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/26/2010 11:10'!
confirmAccountChangesViaEmail
	^ self application preferenceAt: #confirmAccountChangesViaEmail! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/26/2010 11:09'!
confirmEmailChangeViaEmail
	^ self application preferenceAt: #confirmEmailChangeViaEmail! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/26/2010 12:04'!
confirmationURL: regId
	^ 'http://' , self session requestContext request host, self session baseUrl asString , '?acctchg=' , regId.! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/2/2011 21:00'!
defaultAccountChangeSubmitFailedComponent
	^ TLAccountChangeSubmitFailed! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/2/2011 21:01'!
defaultAccountChangeSubmittedComponent
	^ TLAccountChangeSubmitted! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/29/2010 15:57'!
dummyPassword
	^'xyzzyabcce562'! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/26/2010 14:02'!
emailChangeConfirmationEmailSender
	^ emailChangeConfirmationEmailSender
	! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/16/2010 17:32'!
emailChangeConfirmationEmailSender: aTwoArgBlock
	emailChangeConfirmationEmailSender := aTwoArgBlock
	! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/5/2011 09:17'!
initialize
	super initialize.
	self reset! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/5/2011 08:29'!
initializeFormValues
	| user |
	user := self session user.
	newUsername := user username.
	newEmail := user email.
	newPassword := self dummyPassword.
	newPasswordConfirm := newPassword.
	^ user! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 06:32'!
loginComponent
	^ loginComponent! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 06:32'!
loginComponent: aLoginComponent
	loginComponent := aLoginComponent! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/5/2011 09:02'!
newPasswordConfirmMismatch
	^ newPasswordMismatch := (newPassword ~= newPasswordConfirm).
! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/29/2010 16:01'!
newUser

	| user |	
	user := self oldUser copy.
	user 
		email: newEmail;
		username: newUsername.
	newPassword = self dummyPassword
		ifFalse: [
			user password: newPassword ].
	^ user! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/5/2011 08:57'!
newUsernameExists
	^ usernameExists := self session user username ~= newUsername
		and: [ self loginComponent authenticationManager usernameExists: newUsername ]! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/2/2011 07:02'!
oldUser
	^ self loginComponent authenticationManager userForUsername: self session user username.
! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/5/2011 09:15'!
passwordIsInvalid
	^ passwordIsInvalid := (self loginComponent authenticationManager verifyPassword: currentPassword for: self session user) not.
! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/9/2011 12:53'!
renderApplicationProperties: user on: html
	user applicationProperties keysSortedSafely
		do: [ :k | 
			| v |
			v := user applicationProperties at: k.
			((v isKindOf: TLApplicationPropertyItem) and: [ v includeInAccountDetails])
				ifTrue: [ 
					html
						tableRow: [ 
							html tableData: k , ': '.
							html tableData: v ] ] ]! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/9/2011 12:16'!
renderButtonsOn: html
	^ html
		tableRow: [ 
			html tableData.
			html tableData: [ 
					(html button)
						class: 'editaccountcancelbutton';
						callback: [ self cancel ];
						with: 'Cancel'.
					(html button)
						id: 'editacctokbtn';
						class: 'editaccountokbutton';
						callback: [ self save ];
						with: 'Ok' ] ]! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/9/2011 14:19'!
renderConfirmationOn: html

	emailResult
		ifTrue: [ 
			html render: (self accountChangeSubmittedComponent new onAnswer: [ self answer ]) ]
		ifFalse: [ 
			html render: (self accountChangeSubmitFailedComponent new onAnswer: [ self answer ]) ].
	self reset.
! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/5/2011 08:31'!
renderContentOn: html
	emailResult
		ifNotNilDo: [ :result | 
			self renderConfirmationOn: html.
			^ self ].
	self renderFormOn: html! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/9/2011 12:22'!
renderCurrentPasswordEntryOn: html
	html
		tableRow: [ 
			html tableData: 'Current password: '.
			html tableData: [ 
				(html passwordInput)
					id: 'editacctpswd';
					callback: [ :v | currentPassword := v ] ] ]! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/9/2011 12:24'!
renderEmailAddressFor: user on: html
	html
		tableRow: [ 
			html tableData: 'Email address: '.
			html tableData: [ 
					(html textInput)
						id: 'editacctemail';
						class: 'editaccountinput';
						callback: [ :v | newEmail := v ];
						with: user email ] ]! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/6/2011 19:54'!
renderErrorsOn: html
	self renderInvalidPasswordErrorOn: html.
	self renderNewPasswordMismatchErrorOn: html.
	self renderUsernameExistsErrorOn: html.
	self renderPasswordValidationErrorOn: html! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/5/2011 08:37'!
renderFormContentFor: user on: html
	self renderErrorsOn: html.
	^ html
		table: [ 
			self renderUsernameEntry: user on: html.
			self renderLoginCountFor: user on: html.
			self renderLastLoginFor: user on: html.
			self renderEmailAddressFor: user on: html.
			self renderPasswordEditorOn: html.
			self renderApplicationProperties: user on: html.
			self renderCurrentPasswordEntryOn: html.
			self renderButtonsOn: html ]! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/5/2011 08:32'!
renderFormOn: html
	| user |
	user := self initializeFormValues.
	(html form)
		class: 'editaccountform';
		onKeyUp: 'enableOkButton()';
		script: 'enableOkButton()';
		with: [ self renderFormContentFor: user on: html ]! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/5/2011 09:15'!
renderInvalidPasswordErrorOn: html
	passwordIsInvalid
		ifTrue: [ 
			(html div)
				class: 'autherror';
				with: 'Invalid password. Try again.' ]! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/9/2011 12:23'!
renderLastLoginFor: user on: html
	html
		tableRow: [ 
			html tableData: 'Last login: '.
			html tableData: [ 
					html text: user lastLoginFormatted.
					html text: ' from '.
					html text: user lastLoginFrom ] ]! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/9/2011 12:23'!
renderLoginCountFor: user on: html
	html
		tableRow: [ 
			html tableData: 'Login count: '.
			html tableData: user loginCount asString ]! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/5/2011 09:14'!
renderNewPasswordMismatchErrorOn: html
	newPasswordMismatch
		ifTrue: [ 
			(html div)
				class: 'autherror';
				with: 'New password confirmation mismatch. Try again' ]! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/9/2011 12:26'!
renderPasswordEditorOn: html
	html
		tableRow: [ 
			html tableData: 'New password: '.
			html tableData: [ 
					(html passwordInput)
						id: 'editacctnewpswd';
						callback: [ :v | newPassword := v ];
						class: 'editaccountinput';
						exampleText: newPassword ] ].
	html
		tableRow: [ 
			html tableData: 'New password Confirm: '.
			html tableData: [ 
					(html passwordInput)
						id: 'editacctnewpswdconf';
						callback: [ :v | newPasswordConfirm := v ];
						class: 'editaccountinput';
						exampleText: newPasswordConfirm ] ]! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/9/2011 11:52'!
renderPasswordValidationErrorOn: html
	passwordValidationError isNil
		ifFalse: [ 
			(html div)
				class: 'autherror';
				with: passwordValidationError ]! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/9/2011 12:23'!
renderUsernameEntry: user on: html
	html
		tableRow: [ 
			html tableData: 'Username: '.
			html tableData: [ 
					(html textInput)
						id: 'editacctusername';
						class: ((self allowUsernameChange) ifTrue: ['editaccountinput'] ifFalse: ['editaccountroinput']);
						readonly: self allowUsernameChange not;
						callback: [ :v | newUsername := v ];
						with: user username ] ]! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/5/2011 09:14'!
renderUsernameExistsErrorOn: html
	usernameExists
		ifTrue: [ 
			(html div)
				class: 'autherror';
				with: 'That username is already taken.. Try again' ]! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/8/2011 09:32'!
reset

	usernameExists := false.
	newPasswordMismatch := false.
	passwordIsInvalid := false.
	emailResult := nil.
	passwordValidationError := nil.! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/6/2011 19:55'!
save
	self reset.
	(self passwordIsInvalid or: [ self newPasswordConfirmMismatch or: [ self newUsernameExists or: [ self validatePassword isNil not ]]])
		ifTrue: [ ^self ]
		ifFalse: [
			self saveChangesOrSendConfirmationEmail.
			loginComponent resetLoginCookies]! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/5/2011 09:12'!
saveChanges
	| newUser |
	newUser := self newUser.
	self loginComponent authenticationManager updateUser: newUser.
	self session user: newUser.
	self reset.
! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/9/2011 11:53'!
saveChangesOrSendConfirmationEmail
	| oldUser |
	oldUser := self loginComponent authenticationManager userForUsername: self session user username.
	(self confirmEmailChangeViaEmail and: [ oldUser email ~= newEmail ])
		ifTrue: [ 
			emailResult := self confirmAccountChangesViaEmail
				ifTrue: [ self sendAccountChangeConfirmationEmail ]
				ifFalse: [ self sendEmailChangeConfirmationEmail ] ]
		ifFalse: [ 
			self confirmAccountChangesViaEmail
				ifTrue: [ emailResult := self sendAccountChangeConfirmationEmail ]
				ifFalse: [ 
					self saveChanges.
					self answer ] ]! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/3/2011 09:52'!
script
	^
		self allowEmptyPassword
			ifTrue: [
				'function enableOkButton() {
					document.getElementById("editacctokbtn").disabled = (
						document.getElementById("editacctusername").value == "" ||
						document.getElementById("editacctemail").value == ""
						);
			}']
			ifFalse: [
				'function enableOkButton() {
					document.getElementById("editacctokbtn").disabled = (
						document.getElementById("editacctusername").value == "" ||
						document.getElementById("editacctemail").value == "" ||
						document.getElementById("editacctpswd").value == ""
						);
				}']
! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/7/2011 16:03'!
sendAccountChangeConfirmationEmail

	| regId  newUser |
	regId := self loginComponent authenticationManager generateRegId.
	newUser := self newUser.
	self loginComponent authenticationManager addPendingAccountChange: newUser regId: regId. 
	^ self accountChangeConfirmationEmailSender
		value: (self confirmationURL: regId )
		value: newUser email
		value: (self application preferenceAt: #confirmationTimeoutMinutes)
		value: newUser
! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/2/2011 20:38'!
sendEmailChangeConfirmationEmail

	| regId newUser |
	regId := self loginComponent authenticationManager generateRegId.
	newUser := self newUser.
	self loginComponent authenticationManager addPendingAccountChange: newUser regId: regId. 
	Transcript cr; show:  (self confirmationURL: regId).
	^ self emailChangeConfirmationEmailSender
		value: (self confirmationURL: regId )
		value: newUser email
		value: (self application preferenceAt: #confirmationTimeoutMinutes)
		value: newUser
! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/16/2010 10:56'!
style
	^'
	.hdr { font-size: 18pt; font-weight: 700; color: #404080; padding: 10px 10px 20px 10px; }
	
	.prefs { padding: 10px; margin-bottom: 20px; margin-left: 10px; border: 1px solid #404080; width: 600px; }
	
	.logregform { padding: 10px; }
	
	.autherror { padding: 20px 10px 20px 10px; color: darkred; }
	
	.loginform { padding: 10px; }
	
	.loggedin { padding: 10px }
	
	.regsubmitfailed { padding: 20px 10px 20px 10px; color: darkred; }
	
	'! !

!TLEditAccountComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/6/2011 19:58'!
validatePassword
	^ (passwordValidationError := loginComponent validateNewPassword: newPassword)! !

WAComponent subclass: #TLForgotPassword
	instanceVariableNames: 'emailSender loginComponent passwordEmailSentComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TF-Login'!

!TLForgotPassword class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 06:41'!
loginComponent: aLoginComponent mailSender: aThreeArgEmailSender
	^ self basicNew
		initialize;
		loginComponent: aLoginComponent;
		emailSender: aThreeArgEmailSender;
		yourself ! !

!TLForgotPassword class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 06:42'!
new
	self shouldNotImplement ! !

!TLForgotPassword methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/9/2011 11:57'!
confirmationURL: confirmId
	^ 'http://' , self session requestContext request host, self session baseUrl asString , '?reset=' , confirmId.
! !

!TLForgotPassword methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/2/2011 21:05'!
defaultPasswordEmailSentComponent
	^TLPasswordEmailSent ! !

!TLForgotPassword methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/9/2010 20:37'!
emailSender: aThreeArgBlock
	emailSender := aThreeArgBlock! !

!TLForgotPassword methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 06:39'!
loginComponent 
	^ loginComponent! !

!TLForgotPassword methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 06:40'!
loginComponent: aLoginComponent
	loginComponent := aLoginComponent ! !

!TLForgotPassword methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/2/2011 21:05'!
passwordEmailSentComponent
	^ passwordEmailSentComponent ifNil: [ TLPasswordEmailSent ]! !

!TLForgotPassword methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/2/2011 20:20'!
passwordEmailSentComponent: aWAComponent
	passwordEmailSentComponent := aWAComponent ! !

!TLForgotPassword methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/12/2011 08:36'!
renderContentOn: html
	html form
		class: 'forgotpasswordform';
		with: [ 
			html text: 'Enter your username below and we will send an email message to you that will allow you to set a new password.'; break.
			html text: 'Username '.
			html textInput
				id: 'forgotpasswordusername';
				callback: [ :v |
					self sendEmail: v ].
			html break. 
			html button
				id: 'forgotpasswordokbtn';
				callback: [
					self answer ];
				with: 'Ok']! !

!TLForgotPassword methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/12/2011 08:38'!
sendEmail: username
	self sendPasswordResetEmailTo: username.
	self call: self passwordEmailSentComponent new.
	self answer
! !

!TLForgotPassword methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/9/2011 11:51'!
sendPasswordResetEmailTo: username
	| user resetId |
	(user := self loginComponent authenticationManager userForUsername: username) notNil
		ifFalse: [ ^ self ].
	resetId := self loginComponent authenticationManager generateRegId.
	self loginComponent authenticationManager addPendingPasswordResetUser: user regId: resetId.
	emailSender
		value: (self confirmationURL: resetId)
		value: user email
		value: (self application preferenceAt: #confirmationTimeoutMinutes)! !

WAComponent subclass: #TLForgotUsername
	instanceVariableNames: 'emailSender loginComponent usernameEmailSentComponent username'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TF-Login'!

!TLForgotUsername class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 06:43'!
loginComponent: aLoginComponent mailSender: aTwoArgEmailSender
	^ self basicNew
		initialize;
		loginComponent: aLoginComponent;
		emailSender: aTwoArgEmailSender;
		yourself ! !

!TLForgotUsername class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 06:43'!
new
	^ self shouldNotImplement ! !

!TLForgotUsername methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/3/2011 08:10'!
cancel
	self answer! !

!TLForgotUsername methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/2/2011 21:10'!
defaultUsernameEmailSentComponent
	^ TLUsernameEmailSent ! !

!TLForgotUsername methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/9/2010 13:54'!
emailSender: aTwoArgBlock
	emailSender := aTwoArgBlock! !

!TLForgotUsername methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 06:54'!
loginComponent
	^ loginComponent! !

!TLForgotUsername methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 06:55'!
loginComponent: aLoginComponent
	loginComponent := aLoginComponent ! !

!TLForgotUsername methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/10/2011 13:34'!
renderContentOn: html
	html form
		class: 'forgotusernameform';
		with: [ 
			html div: 'Enter your email address below and we will send an email message to you containing your username.'.
			html
				text: 'Email '.
			html textInput
				id: 'forgotusernameemail';
				callback: [ :v | username := v].
			html button
				id: 'forgotusernameokbtn';
				callback: [ self send ];
				with: 'Ok'.
			html button
				id: 'forgotusernamecancelbtn';
				callback: [ self cancel ];
				with: 'Cancel']		! !

!TLForgotUsername methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/3/2011 08:10'!
send
	| users |
	username isNil ifFalse: [
		users := self loginComponent authenticationManager usersForEmail: username.
		users isEmpty
			ifFalse: [
				self sendUsernames: users to: username ].
		self call: self usernameEmailSentComponent new].
	self answer	! !

!TLForgotUsername methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/10/2010 07:53'!
sendUsernames: users to: email
	emailSender
		value: (users collect: [ :each | each username ])
		value: email
		! !

!TLForgotUsername methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/2/2011 20:29'!
usernameEmailSentComponent
	^ usernameEmailSentComponent ifNil: [ self defaultUsernameEmailSentComponent ]! !

!TLForgotUsername methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/2/2011 20:30'!
usernameEmailSentComponent: aWAComponent
	usernameEmailSentComponent := aWAComponent ! !

WAComponent subclass: #TLLoginComponentBase
	instanceVariableNames: 'accountChangeConfirmed appName user rememberPassword rememberUsername userRegistrationHandler resetConfirmed userActionConfirmed usernameReminderEmailSender passwordValidator registerComponent registrationConfirmationEmailSender registrationConfirmationEmail registrationConfirmed resetPassword automaticLogin authenticationManager passwordResetEmailSender onLoginFailBlock onLoginBlock loginDisallowed username pswd authenticationError'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TF-Login'!

!TLLoginComponentBase commentStamp: '<historical>' prior: 0!
I am the abstract base class of TLLoginComponent. I implement the methods common to any concrete login component that wants to play in the TFLogin framework.!

TLLoginComponentBase subclass: #TLLoginComponent
	instanceVariableNames: 'captchaComponent confirmationTimeout children registrationSubmitFailedComponent registrationSubmittedComponent forgotPasswordComponent forgotUsernameComponent defaultRegistrationSubmitFailedComponent resetPasswordComponent authenicationErrorText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TF-Login'!

!TLLoginComponent methodsFor: 'rendering' stamp: 'TonyFleig 1/8/2011 09:47'!
authenticationErrorText
	^ authenicationErrorText ifNil: [ self defaultAuthenticationErrorText ]
! !

!TLLoginComponent methodsFor: 'rendering' stamp: 'TonyFleig 1/8/2011 09:46'!
authenticationErrorText: aString
	authenicationErrorText := aString
! !

!TLLoginComponent methodsFor: 'seaside' stamp: 'TonyFleig 1/3/2011 16:59'!
children
	^ Array with: registerComponent
! !

!TLLoginComponent methodsFor: 'rendering' stamp: 'TonyFleig 1/8/2011 09:48'!
defaultAuthenticationErrorText  
	^ 'Authentication error: Username or password is invalid.'! !

!TLLoginComponent methodsFor: 'email-confirmation' stamp: 'TonyFleig 11/28/2010 18:01'!
defaultConfirmationTimeout
	^ 60 *10 "10 minutes as seconds"! !

!TLLoginComponent methodsFor: 'default-components' stamp: 'TonyFleig 1/2/2011 21:04'!
defaultForgotPasswordComponent
	^ TLForgotPassword ! !

!TLLoginComponent methodsFor: 'default-components' stamp: 'TonyFleig 1/2/2011 21:05'!
defaultForgotUsernameComponent
	^ TLForgotUsername! !

!TLLoginComponent methodsFor: 'default-components' stamp: 'TonyFleig 1/2/2011 21:05'!
defaultRegisterComponent
	^ TLRegisterComponent ! !

!TLLoginComponent methodsFor: 'default-components' stamp: 'TonyFleig 1/2/2011 21:06'!
defaultRegistrationSubmitFailedComponent
	^ TLRegistrationSubmitFailed! !

!TLLoginComponent methodsFor: 'default-components' stamp: 'TonyFleig 1/2/2011 21:06'!
defaultRegistrationSubmittedComponent
	^ TLRegistrationSubmitted! !

!TLLoginComponent methodsFor: 'default-components' stamp: 'TonyFleig 1/5/2011 16:17'!
defaultResetPasswordComponent
	^ TLResetPasswordComponent ! !

!TLLoginComponent methodsFor: 'password-reset' stamp: 'TonyFleig 1/2/2011 20:05'!
forgotPasswordComponent
	^ forgotPasswordComponent ifNil: [self defaultForgotPasswordComponent]! !

!TLLoginComponent methodsFor: 'password-reset' stamp: 'TonyFleig 1/2/2011 20:12'!
forgotPasswordComponent: aWAComponent 
	forgotPasswordComponent := aWAComponent ! !

!TLLoginComponent methodsFor: 'username-reminder' stamp: 'TonyFleig 1/2/2011 20:11'!
forgotUsernameComponent
	^forgotUsernameComponent ifNil: [ self defaultForgotUsernameComponent  ]! !

!TLLoginComponent methodsFor: 'username-reminder' stamp: 'TonyFleig 1/2/2011 20:07'!
forgotUsernameComponent: aWAComponent
	forgotUsernameComponent := aWAComponent ! !

!TLLoginComponent methodsFor: 'login-logout' stamp: 'TonyFleig 1/9/2011 09:58'!
inhibitAuthError
	"authenticationError := nil"! !

!TLLoginComponent methodsFor: 'registration' stamp: 'TonyFleig 1/2/2011 20:22'!
registrationSubmitFailedComponent
	^ registrationSubmitFailedComponent ifNil: [ self defaultRegistrationSubmitFailedComponent ]! !

!TLLoginComponent methodsFor: 'registration' stamp: 'TonyFleig 1/2/2011 20:22'!
registrationSubmitFailedComponent: aWAComponent
	registrationSubmitFailedComponent := aWAComponent ! !

!TLLoginComponent methodsFor: 'registration' stamp: 'TonyFleig 1/2/2011 20:23'!
registrationSubmittedComponent
	^ registrationSubmittedComponent ifNil: [self defaultRegistrationSubmittedComponent ]! !

!TLLoginComponent methodsFor: 'registration' stamp: 'TonyFleig 1/2/2011 19:45'!
registrationSubmittedComponent: aWAComponent
	registrationSubmittedComponent := aWAComponent ! !

!TLLoginComponent methodsFor: 'rendering' stamp: 'TonyFleig 1/9/2011 14:28'!
renderAccountChangeConfirmation: html

	accountChangeConfirmed isNil
		ifTrue: [ ^ self ].
	accountChangeConfirmed
		ifTrue: [ 
			(html div)
				class: 'loginconfsuccess';
				with: [ 
							html
								text: 'Your account changes have been confirmed.';
								break;
								text: 'You may now log in.';
								break ] ]
		ifFalse: [ 
			(html div)
				class: 'loginconffailed';
				with: [ 
							html
								text: 'Your account change confirmation failed.';
								break;
								text: 'Perhaps you waited too long to confirm after receiving the email.';
								break ] ].
	accountChangeConfirmed := nil! !

!TLLoginComponent methodsFor: 'rendering' stamp: 'TonyFleig 1/9/2011 12:24'!
renderAuthenticationError: html
	self authenticationError
		ifFalse: [ ^ self ].
	authenticationError := false.
	(html div)
		class: 'autherror';
		with: self authenticationErrorText! !

!TLLoginComponent methodsFor: 'rendering' stamp: 'TonyFleig 1/9/2011 09:51'!
renderConfirmations: html
	self renderRegistrationConfirmation: html.
	self renderAccountChangeConfirmation: html.
	self renderUserActionConfirmation: html.! !

!TLLoginComponent methodsFor: 'rendering' stamp: 'TonyFleig 1/9/2011 11:51'!
renderContentOn: html
	(self renderReset: html)
		ifTrue: [ ^ self ].
	self renderConfirmations: html.
	(self renderLoginDisallowed: html)
		ifFalse: [ self renderAuthenticationError: html ].
	self renderLoginForm: html! !

!TLLoginComponent methodsFor: 'rendering' stamp: 'TonyFleig 1/13/2011 09:30'!
renderLoginDisallowed: html
	^ self loginDisallowed isNil not
		ifTrue: [
			authenticationError := false.
			html div
				class: 'autherror';
				with: self loginDisallowed.
			true]
		ifFalse: [ false ]
! !

!TLLoginComponent methodsFor: 'rendering' stamp: 'TonyFleig 1/10/2011 08:53'!
renderLoginForm: html
	| ucookie pcookie |
	ucookie := self session requestContext request cookieAt: (self appName, '-001').
	pcookie := self session requestContext request cookieAt: (self appName, '-002').
	html form
		class: 'loginform';
		onKeyUp: ('enableLoginButton()');
		script: ('enableLoginButton(); document.getElementById("loginuser").focus();');
		defaultAction: [self login];
		with: [
		html table: [
			html tableRow: [
				html tableData: 'Username:'.
				html tableData: [
					html textInput
						id: 'loginuser';
						onChange: ('enableLoginButton()');
						callback: [ :v | username := v ];
						with: (ucookie isNil ifTrue: [''] ifFalse: [(Base64MimeConverter mimeDecodeToChars: (ReadStream on: ucookie value)) contents]).
					html button
						id: 'forgotusernamebtn';
						callback: [ self forgotUsername ];
						with: 'Forgot username' ]].
			html tableRow: [
				html tableData: 'Password:'.
				html tableData: [
					html passwordInput
						id: 'loginpswd';
						onChange: ('enableLoginButton()');
				 		callback: [ :v | pswd := v ];
						with: ''.
					html button
						id: 'forgotpasswordbtn';
						callback: [ self forgotPassword ];
						with: 'Forgot password' ]].
			html tableRow: [
				html tableData.
				html tableData: [
					html button
						beSubmit;
						id: 'loginbtn';
						disabled: true;
						callback: [ self login ];
						with: 'Login'.
					html button
						id: 'registerbtn';
						callback: [ self register];
						with: 'Register']].
			self allowRememberUsername ifTrue: [
				html tableRow: [
				html tableData.
				html tableData: [
					html checkbox
						value: (ucookie isNil not);
						callback: [ :v |  self rememberUsername: v ];
						with: 'Remember my username on this computer.']]].
			self allowAutomaticLogin ifTrue: [
					html tableRow: [
						html tableData.
						html tableData: [
							html checkbox
								value: (pcookie isNil not);
								callback: [ :v | self automaticLogin: v. ];
								with: 'Log me in automatically when I return to this website.']]]]]
! !

!TLLoginComponent methodsFor: 'rendering' stamp: 'TonyFleig 1/9/2011 11:51'!
renderRegistrationConfirmation: html
	registrationConfirmed isNil
		ifTrue: [ ^ self ].
	registrationConfirmed
		ifTrue: [ 
			(html div)
				class: 'loginconfsuccess';
				with: [ 
							html
								text: 'Your registration has been confirmed.';
								break;
								text: 'You may now log in.';
								break ] ]
		ifFalse: [ 
			(html div)
				class: 'loginconffailed';
				with: [ 
							html
								text: 'Your registration confirmation failed.';
								break;
								text: 'Perhaps you waited too long to confirm after receiving the email.';
								break ] ].
	registrationConfirmed := nil! !

!TLLoginComponent methodsFor: 'rendering' stamp: 'TonyFleig 12/10/2010 12:44'!
renderReset: html
	"Answer true if password reset page was rendered."
	^ resetPassword notNil
		ifTrue: [
			html render: resetPassword.
			true]
		ifFalse: [ false ]
! !

!TLLoginComponent methodsFor: 'rendering' stamp: 'TonyFleig 1/9/2011 11:51'!
renderUserActionConfirmation: html
	userActionConfirmed isNil
		ifTrue: [ ^ self ].
	userActionConfirmed
		ifFalse: [ 
			(html div)
				class: 'loginconffailed';
				with: [ 
							html
								text: 'Requested action failed.';
								break;
								text: 'Perhaps you waited too long to confirm after receiving the email.';
								break ] ].
	userActionConfirmed := nil! !

!TLLoginComponent methodsFor: 'password-reset' stamp: 'TonyFleig 1/2/2011 20:27'!
resetPasswordComponent
	^ resetPasswordComponent ifNil: [ self defaultResetPasswordComponent ]! !

!TLLoginComponent methodsFor: 'password-reset' stamp: 'TonyFleig 1/2/2011 20:27'!
resetPasswordComponent: aWAComponent
	resetPasswordComponent := aWAComponent ! !

!TLLoginComponent methodsFor: 'javascript' stamp: 'TonyFleig 1/5/2011 16:15'!
script
	^ (self allowEmptyPassword
		ifFalse: [
			'function enableLoginButton() {
				document.getElementById("loginbtn").disabled = (
					document.getElementById("loginuser").value == "" ||
					document.getElementById("loginpswd").value == "" );
			}	
			function enableResetButton() {
				document.getElementById("resetbtn").disabled = (
					document.getElementById("resetpswduser").value == "" ||
					document.getElementById("resetpswd").value == "" ||
					document.getElementById("resetpswdconfirm").value == "" );
			}
			']
		ifTrue: [
			'function enableLoginButton() {
				document.getElementById("loginbtn").disabled = (
					document.getElementById("loginuser").value == "" );
			}	
			function enableResetButton() {
				document.getElementById("resetbtn").disabled = (
					document.getElementById("resetpswduser").value == "" ||
					document.getElementById("resetpswd").value !!= document.getElementById("resetpswdconfirm").value);
			}
			'])
	! !

!TLLoginComponentBase class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/9/2011 07:48'!
appName: aString
	^self new appName: aString! !

!TLLoginComponentBase class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/9/2011 07:49'!
initialize
	"Write the document TFLogin Guide to TFLoginGuide.txt and then display it in a workspace."
	"TFLoginComponent initialize"
	
	| ws |
	(FileStream forceNewFileNamed: 'TFLoginGuide.txt')
		nextPutAll: self tfLoginGuide;
		close.
	ws := (Workspace openFile: 'TFLoginGuide.txt')
		label: 'TFLoginGuide.txt'.
	ws topView
		position: 100@100;
		extent: 800@400! !

!TLLoginComponentBase class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/11/2011 20:10'!
tfLoginGuide

^ (GZipReadStream on: (Base64MimeConverter mimeDecodeToChars:
'H4sIAAAAAAAAAMVcbZPbRnL+vB/4H6bWH6it41KW41xSlOPKWi/nza1sRbs6JbmSq0BiSOIW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'
readStream) contents) contents! !

!TLLoginComponentBase methodsFor: 'login-logout' stamp: 'TonyFleig 1/9/2011 07:54'!
accountChangeConfirmed
	^ accountChangeConfirmed! !

!TLLoginComponentBase methodsFor: 'login-logout' stamp: 'TonyFleig 1/9/2011 14:25'!
accountChangeConfirmed: confirmId

	accountChangeConfirmed := self authenticationManager confirmAccountChange: confirmId! !

!TLLoginComponentBase methodsFor: 'useractions' stamp: 'TonyFleig 1/9/2011 07:56'!
addPendingUserAction: aPendingUserAction
	aPendingUserAction regId: self authenticationManager generateRegId.
	self authenticationManager addPendingUserAction: aPendingUserAction.
	^ self userActionConfirmationURL: aPendingUserAction regId.! !

!TLLoginComponentBase methodsFor: 'configuration' stamp: 'TonyFleig 1/9/2011 07:56'!
allowAutomaticLogin
	^ self application preferenceAt: #allowAutomaticLogin! !

!TLLoginComponentBase methodsFor: 'configuration' stamp: 'TonyFleig 1/9/2011 07:56'!
allowEmptyPassword
	^ self application preferenceAt: #allowEmptyPasswords ! !

!TLLoginComponentBase methodsFor: 'configuration' stamp: 'TonyFleig 1/9/2011 07:57'!
allowRememberPassword 
	^ self application preferenceAt: #allowRememberPassword ! !

!TLLoginComponentBase methodsFor: 'configuration' stamp: 'TonyFleig 1/9/2011 07:57'!
allowRememberUsername 
	^ self application preferenceAt: #allowRememberUsername ! !

!TLLoginComponentBase methodsFor: 'configuration' stamp: 'TonyFleig 1/9/2011 07:57'!
allowUsernameChange 
	^ self application preferenceAt: #allowUsernameChange ! !

!TLLoginComponentBase methodsFor: 'initialize-release' stamp: 'TonyFleig 1/9/2011 07:58'!
appName
	^ appName ifNil: [ self name ]! !

!TLLoginComponentBase methodsFor: 'initialize-release' stamp: 'TonyFleig 1/9/2011 07:58'!
appName: aString
	appName := aString! !

!TLLoginComponentBase methodsFor: 'cookies' stamp: 'TonyFleig 1/9/2011 09:56'!
authenticationError
	^ authenticationError ifNil: [ false ]! !

!TLLoginComponentBase methodsFor: 'login-logout' stamp: 'TonyFleig 1/10/2011 11:59'!
authenticationManager
	^ authenticationManager ifNil: [
		authenticationManager := TLAuthenticationManager loginComponent: self ]! !

!TLLoginComponentBase methodsFor: 'login-logout' stamp: 'TonyFleig 1/9/2011 08:39'!
automaticLogin
	^ automaticLogin ifNil: [ ^ false ]! !

!TLLoginComponentBase methodsFor: 'login-logout' stamp: 'TonyFleig 1/9/2011 08:40'!
automaticLogin: aBoolean
	^ automaticLogin := aBoolean! !

!TLLoginComponentBase methodsFor: 'cookies' stamp: 'TonyFleig 1/9/2011 07:59'!
clearLoginCookies
	self
		clearUsernameCookie;
		clearPasswordCookie ! !

!TLLoginComponentBase methodsFor: 'cookies' stamp: 'TonyFleig 1/9/2011 07:59'!
clearPasswordCookie
	| pcookie |
	pcookie := self session requestContext request cookieAt: (self appName, '-002').
	pcookie ifNotNilDo: [ :cookie |
		self session requestContext response deleteCookie: cookie].
! !

!TLLoginComponentBase methodsFor: 'cookies' stamp: 'TonyFleig 1/9/2011 07:59'!
clearUsernameCookie
	| ucookie |
	ucookie := self session requestContext request cookieAt: (self appName, '-001').
	ucookie ifNotNilDo: [ :cookie |
		self session requestContext response deleteCookie: cookie].
	
! !

!TLLoginComponentBase methodsFor: 'cookies' stamp: 'TonyFleig 1/10/2011 12:03'!
confirmationTimeout 
	^ self application preferenceAt: #confirmationTimeoutMinutes! !

!TLLoginComponentBase methodsFor: 'email-confirmation' stamp: 'TonyFleig 1/9/2011 08:41'!
confirmationURLKey: aKey id: regId

	^ 'http://' , self session requestContext request host, '/',self session url path first asString , '?', aKey, '=' , regId.
! !

!TLLoginComponentBase methodsFor: 'cookies' stamp: 'TonyFleig 1/9/2011 09:55'!
cookieLogin
	| uname encpswd ucookie pcookie |
	
	accountChangeConfirmed ifNotNilDo: [ :bool | ^ false ].
	
	ucookie := self session requestContext request cookieAt: (self appName, '-001').
	pcookie := self session requestContext request cookieAt: (self appName, '-002').
	(ucookie isNil or: [ pcookie isNil]) ifTrue: [ ^ false ].
	uname := (Base64MimeConverter mimeDecodeToChars: (ReadStream on: ucookie value)) contents.
	encpswd := (Base64MimeConverter mimeDecodeToChars: (ReadStream on: pcookie value)) contents.
	user := self authenticationManager loginUser: uname encryptedPassword: encpswd from: self session requestContext request remoteAddress.	
	user isNil
		ifTrue: [ ^ false ]
		ifFalse: [
			authenticationError := nil.
			self rememberUsernameInCookie: user username.
			self rememberPasswordInCookie: (self authenticationManager registeredUserFor: user) encryptedPassword.
			self session user: user.
			self answer: user ]! !

!TLLoginComponentBase methodsFor: 'persistence' stamp: 'TonyFleig 1/9/2011 08:43'!
deleteLoggedInUser
	| userToDelete |
	userToDelete := self session user.
	self logout.
	self authenticationManager deleteUser: userToDelete! !

!TLLoginComponentBase methodsFor: 'cookies' stamp: 'TonyFleig 1/9/2011 08:01'!
deleteLoginCookies
	| ucookie pcookie |
	ucookie := self session requestContext request cookieAt: (self appName, '-001').
	pcookie := self session requestContext request cookieAt: (self appName, '-002').
	ucookie ifNotNilDo: [ :cookie | self session requestContext response deleteCookie: cookie].
	pcookie ifNotNilDo: [ :cookie | self session requestContext response deleteCookie: cookie].
! !

!TLLoginComponentBase methodsFor: 'password-reset' stamp: 'TonyFleig 1/9/2011 08:42'!
forgotPassword
	self call: (self forgotPasswordComponent  loginComponent: self mailSender: passwordResetEmailSender) ! !

!TLLoginComponentBase methodsFor: 'username-reminder' stamp: 'TonyFleig 1/9/2011 08:41'!
forgotUsername
	self call: (self forgotUsernameComponent loginComponent: self mailSender: usernameReminderEmailSender) ! !

!TLLoginComponentBase methodsFor: 'registration' stamp: 'TonyFleig 1/9/2011 08:12'!
goRegister

	(self call: registerComponent)
		ifTrue: [	
			^ self authenticationManager  
				addPendingRegistrationUser: (registerComponent  username)
				password:  (registerComponent  password)
				email: (registerComponent  email)
				regId: self authenticationManager generateRegId ]
		ifFalse: [ ^nil ]
		
! !

!TLLoginComponentBase methodsFor: 'email-confirmation' stamp: 'TonyFleig 1/9/2011 12:42'!
initialRequest: aRequest 

	| regid |
	super initialRequest: aRequest.
	regid := aRequest queryFields at: 'regconfirm' ifAbsent: [ nil ].
	regid isNil ifFalse: [
		self registrationConfirmed: regid ].
	regid := aRequest queryFields at: 'reset' ifAbsent: [ nil ].
	regid isNil ifFalse: [
		(self resetConfirmed: regid)
			notNil ifTrue: [
				resetPassword := (self resetPasswordComponent loginComponent: self pendingReset: self resetConfirmed) ] ].
	regid := aRequest queryFields at: 'acctchg' ifAbsent: [ nil ].
	regid isNil ifFalse: [
		self accountChangeConfirmed: regid ].
	regid := aRequest queryFields at: 'confirm' ifAbsent: [ nil ].
	regid isNil ifFalse: [
		self userActionConfirmed: regid ].
	
	
	
	
! !

!TLLoginComponentBase methodsFor: 'initialize-release' stamp: 'TonyFleig 1/9/2011 08:44'!
initialize
	super initialize.
	registerComponent := self registerComponent loginComponent: self.! !

!TLLoginComponentBase methodsFor: 'login-logout' stamp: 'TonyFleig 1/13/2011 09:30'!
login

	user := self authenticationManager
		loginUser: username
		password: pswd
		from: self session requestContext request remoteAddress.
	user isNil
		ifTrue: [ authenticationError := true.
			self loginDisallowed: (self onLoginFailBlock
				value: username
				value:  self session requestContext request remoteAddress)]
		ifFalse: [
			(self loginDisallowed: (self onLoginBlock value: user)) isNil
				ifTrue: [
					authenticationError := nil.
					self setLoginCookies.
					self session user: user.
					self answer: user ]]! !

!TLLoginComponentBase methodsFor: 'accessing' stamp: 'TonyFleig 1/13/2011 09:30'!
loginDisallowed
	^ loginDisallowed! !

!TLLoginComponentBase methodsFor: 'accessing' stamp: 'TonyFleig 1/13/2011 09:30'!
loginDisallowed: anObject
	^ loginDisallowed := anObject! !

!TLLoginComponentBase methodsFor: 'login-logout' stamp: 'TonyFleig 1/13/2011 09:30'!
loginUserById: aUserId

	user := self authenticationManager
		loginUserById: aUserId
		from: self session requestContext request remoteAddress.
	user isNil
		ifTrue: [ authenticationError := true ]
		ifFalse: [
			(self loginDisallowed: (self onLoginBlock value: user)) isNil
				ifTrue: [
					authenticationError := nil.
					self resetLoginCookies.
					self session user: user.
					self answer: user ]]! !

!TLLoginComponentBase methodsFor: 'login-logout' stamp: 'TonyFleig 1/9/2011 08:47'!
logout
	self clearPasswordCookie.
	self saveUser.
	self session user: nil
	! !

!TLLoginComponentBase methodsFor: 'login-logout' stamp: 'TonyFleig 1/9/2011 08:46'!
logout: aSession
	"For logging out when called from another session. aSession is actually my session. (When called from another
	session, self session returns that other session.) This method allows a session to log out other sessions." 
	aSession user: nil
	! !

!TLLoginComponentBase methodsFor: 'registration' stamp: 'TonyFleig 1/9/2011 08:45'!
onLogin: aOneArgBlock
	"Evaluate this block with the logging-in user object before login is approved.
	The block answers nil to allow the login to proceed or a string containing a message
	to be displayed to the user if the login is disallowed. Example use: this can be used,
	along with an application property, to temporarily disable accounts without deleting them."
	onLoginBlock := aOneArgBlock ! !

!TLLoginComponentBase methodsFor: 'login-logout' stamp: 'TonyFleig 1/9/2011 08:46'!
onLoginBlock
	^ onLoginBlock ifNil: [ [:arg | nil ]]! !

!TLLoginComponentBase methodsFor: 'registration' stamp: 'TonyFleig 1/9/2011 08:46'!
onLoginFail: aTwoArgBlock
	"Evaluate this block with the failed logging-in username and IP address.
	Example use: this can be used, along with an application property, to
	disable accounts after a number of unsuccessful login attempts."
	onLoginFailBlock := aTwoArgBlock ! !

!TLLoginComponentBase methodsFor: 'login-logout' stamp: 'TonyFleig 1/9/2011 08:46'!
onLoginFailBlock
	^ onLoginFailBlock ifNil: [ [:arg1 :arg2 | nil ]]! !

!TLLoginComponentBase methodsFor: 'registration' stamp: 'TonyFleig 1/9/2011 08:06'!
onRegistration: aOneArgBlock
	"Evaluate this block with the newly-constructed pending user object before registration is complete.
	The block may add applicationProperties. The block answers true to allow the registration to proceed."
	userRegistrationHandler := aOneArgBlock ! !

!TLLoginComponentBase methodsFor: 'email-confirmation' stamp: 'TonyFleig 1/9/2011 08:43'!
passwordResetEmailSender:  aThreeArgBlock
	passwordResetEmailSender := aThreeArgBlock! !

!TLLoginComponentBase methodsFor: 'registration' stamp: 'TonyFleig 1/9/2011 08:16'!
passwordValidator: aOneArgBlock
	"passwordValidator is passed the candidate password. If it is acceptable, the block should evaluate to nil.
	Otherwise it should evaluate to the error text to be displayed to the user."
	passwordValidator := aOneArgBlock ! !

!TLLoginComponentBase methodsFor: 'registration' stamp: 'TonyFleig 1/9/2011 12:42'!
register
	| pendingUser |
	authenticationError := false.
	pendingUser := self goRegister.
	
	pendingUser isNil ifFalse: [ 
		(self userRegistrationHandler value: pendingUser)
			ifTrue: [		
				self sendRegistrationConfirmationEmail
					ifTrue: [
						(registrationConfirmationEmailSender
							value: (self registrationConfirmationURL: pendingUser regId)
							value: pendingUser email
							value: (self application preferenceAt: #confirmationTimeoutMinutes))
								ifTrue: [
									self call: self defaultRegistrationSubmittedComponent  new ]
								ifFalse: [
									self call: self defaultRegistrationSubmitFailedComponent new ]]
					ifFalse: [
						self registrationConfirmed: pendingUser regId ]]].
	self answer: nil.! !

!TLLoginComponentBase methodsFor: 'registration' stamp: 'TonyFleig 1/9/2011 08:16'!
registerComponent
	^ registerComponent ifNil: [ self defaultRegisterComponent ]! !

!TLLoginComponentBase methodsFor: 'registration' stamp: 'TonyFleig 1/9/2011 08:16'!
registerComponent: aWAComponent
	registerComponent := aWAComponent ! !

!TLLoginComponentBase methodsFor: 'email-confirmation' stamp: 'TonyFleig 1/9/2011 08:14'!
registrationConfirmationEmailSender:  aThreeArgBlock
	registrationConfirmationEmailSender := aThreeArgBlock! !

!TLLoginComponentBase methodsFor: 'email-confirmation' stamp: 'TonyFleig 1/9/2011 08:14'!
registrationConfirmationURL: regId

	^ 'http://' , self session requestContext request host, '/',self session url path first asString , '?regconfirm=' , regId.
! !

!TLLoginComponentBase methodsFor: 'registration' stamp: 'TonyFleig 1/9/2011 08:15'!
registrationConfirmed 	
	^ registrationConfirmed ! !

!TLLoginComponentBase methodsFor: 'registration' stamp: 'TonyFleig 1/9/2011 09:40'!
registrationConfirmed: regId
	registrationConfirmed := self authenticationManager confirmRegistration: regId
! !

!TLLoginComponentBase methodsFor: 'cookies' stamp: 'TonyFleig 1/9/2011 08:01'!
rememberPasswordInCookie: aPassword
	self setCookieNamed: (self appName,'-002') value: aPassword
! !

!TLLoginComponentBase methodsFor: 'cookies' stamp: 'TonyFleig 1/9/2011 08:03'!
rememberUsername
	^ rememberUsername ifNil: [ ^ false ]! !

!TLLoginComponentBase methodsFor: 'cookies' stamp: 'TonyFleig 1/9/2011 08:03'!
rememberUsername: aBoolean
	rememberUsername := aBoolean! !

!TLLoginComponentBase methodsFor: 'cookies' stamp: 'TonyFleig 1/9/2011 08:03'!
rememberUsernameInCookie: aUsername
	self setCookieNamed: (self appName,'-001') value: aUsername
! !

!TLLoginComponentBase methodsFor: 'password-reset' stamp: 'TonyFleig 1/9/2011 08:07'!
resetConfirmed 	
	^ resetConfirmed ! !

!TLLoginComponentBase methodsFor: 'password-reset' stamp: 'TonyFleig 1/9/2011 08:08'!
resetConfirmed: regId 	
	^ resetConfirmed := self authenticationManager userForPasswordReset: regId
! !

!TLLoginComponentBase methodsFor: 'cookies' stamp: 'TonyFleig 1/9/2011 08:03'!
resetLoginCookies
	| ucookie pcookie |
	ucookie := self session requestContext request cookieAt: (self appName, '-001').
	pcookie := self session requestContext request cookieAt: (self appName, '-002').
	ucookie ifNotNilDo: [ :cookie | self rememberUsernameInCookie: user username ].
	pcookie ifNotNilDo: [ :cookie | self rememberPasswordInCookie: (self authenticationManager userForId: user userId) encryptedPassword ].
! !

!TLLoginComponentBase methodsFor: 'persistence' stamp: 'TonyFleig 1/9/2011 11:52'!
saveUser
	| newUser oldUser |
	self session user isNil
		ifTrue: [ ^ self ].
	oldUser := self authenticationManager userForUsername: self session user username.
	oldUser isNil
		ifTrue: [ ^ self ].
	newUser := oldUser copy updateFromUser: self session user.
	self authenticationManager updateUser: newUser! !

!TLLoginComponentBase methodsFor: 'persistence' stamp: 'TonyFleig 1/9/2011 11:52'!
saveUser: aUser
	"Use this method to save a user other than the currently logged in one."

	| newUser oldUser |
	aUser isNil
		ifTrue: [ ^ self ].
	oldUser := self authenticationManager userForId: aUser userId.
	oldUser isNil
		ifTrue: [ ^ self ].
	newUser := oldUser copy updateFromUser: aUser.
	self authenticationManager updateUser: newUser! !

!TLLoginComponentBase methodsFor: 'persistence' stamp: 'TonyFleig 1/9/2011 08:07'!
saveUserInSession: aSession
	"This method is for use by forked processes in which the session object is not available."
	| newUser oldUser |
	oldUser := self authenticationManager userForUsername: aSession user username.
	newUser := oldUser copy updateFromUser: aSession user.
	self authenticationManager updateUser: newUser.! !

!TLLoginComponentBase methodsFor: 'email-confirmation' stamp: 'TonyFleig 1/9/2011 08:05'!
sendRegistrationConfirmationEmail 
	^ self application preferenceAt: #sendRegistrationConfirmationEmail! !

!TLLoginComponentBase methodsFor: 'cookies' stamp: 'TonyFleig 1/9/2011 12:37'!
setCookieNamed: aName value: aValue
	self requestContext response
		addCookie: (self requestContext newCookie
			key: aName;
			value: (((Base64MimeConverter mimeEncode: (ReadStream on: aValue)) contents) trimRight: [ :c | c = $=]);
			expireIn: self usernamePasswordRememberDays days)! !

!TLLoginComponentBase methodsFor: 'cookies' stamp: 'TonyFleig 1/9/2011 12:43'!
setLoginCookies

	| pcookie |	
	pcookie := self session requestContext request cookieAt: (self appName, '-002').
	(self rememberUsername or: [ self automaticLogin])
				ifTrue: [
					self rememberUsernameInCookie: user username.
					self automaticLogin
						ifTrue: [
							self rememberPasswordInCookie: (self authenticationManager registeredUserFor: user) encryptedPassword  ]
						ifFalse: [
							pcookie ifNotNilDo: [ :cookie |
								self session requestContext response deleteCookie: cookie]]]
				ifFalse: [
					self deleteLoginCookies ]! !

!TLLoginComponentBase methodsFor: 'email-confirmation' stamp: 'TonyFleig 1/9/2011 08:08'!
userActionConfirmationURL: regId
	^ self confirmationURLKey: 'confirm' id: regId 
! !

!TLLoginComponentBase methodsFor: 'email-confirmation' stamp: 'TonyFleig 1/9/2011 08:09'!
userActionConfirmed: regId
	userActionConfirmed := self authenticationManager confirmUserAction: regId.
	
	
! !

!TLLoginComponentBase methodsFor: 'registration' stamp: 'TonyFleig 1/9/2011 08:06'!
userRegistrationHandler
	^ userRegistrationHandler  ifNil: [ [ :arg |  true ]]! !

!TLLoginComponentBase methodsFor: 'configuration' stamp: 'TonyFleig 1/9/2011 08:09'!
usernamePasswordRememberDays 
	^ (self application preferenceAt: #UsernamePasswordRememberDays) asInteger! !

!TLLoginComponentBase methodsFor: 'email-confirmation' stamp: 'TonyFleig 1/9/2011 08:10'!
usernameReminderEmailSender:  aTwoArgBlock
	usernameReminderEmailSender := aTwoArgBlock! !

!TLLoginComponentBase methodsFor: 'registration' stamp: 'TonyFleig 1/9/2011 08:11'!
validateNewPassword: password
	^ (passwordValidator ifNil: [ [ :p |  nil ]]) value: password! !

WAComponent subclass: #TLPasswordEmailSent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TF-Login'!

!TLPasswordEmailSent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/12/2011 08:40'!
renderContentOn: html
	html form
		class: 'passwordemailsent';
		with: [ 
			html text: 'An email message with instrcutions for resetting your password has been sent to the username associated with the username you provided, if any.'; break.
			html button
				id: 'passwordemailsentokbtn';
				callback: [ self answer ];
				with: 'Ok']! !

WAComponent subclass: #TLRegisterComponent
	instanceVariableNames: 'user pswd confpswd email captchaComponent captchaVerified userExists passwordsMatch loginComponent passwordValidationError passwordEmpty'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TF-Login'!

!TLRegisterComponent class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 08:11'!
loginComponent: aLoginComponent
	^ (self basicNew)
		initialize;
		loginComponent: aLoginComponent;
		yourself! !

!TLRegisterComponent class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/31/2010 09:43'!
script

	^'
	function enableRegisterButton() {
		document.getElementById("registerbtn").disabled = (
			document.getElementById("registeruser").value == "" ||
			document.getElementById("registerpswd").value == "" ||
			document.getElementById("registeremail").value == "");
	}'! !

!TLRegisterComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/29/2010 21:38'!
cancel
	self answer: false! !

!TLRegisterComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/26/2010 08:57'!
captchaVerified 
	^captchaVerified ! !

!TLRegisterComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/23/2010 14:57'!
confirmPassword
	^confpswd! !

!TLRegisterComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/23/2010 14:57'!
email
	^email! !

!TLRegisterComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/10/2011 10:42'!
initialize
	super initialize.
	self setRecaptchaComponent.
	captchaVerified  := true.
	userExists  := false.
	passwordsMatch := true.
	passwordEmpty := false.
! !

!TLRegisterComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 08:05'!
loginComponent 
	^ loginComponent! !

!TLRegisterComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 08:05'!
loginComponent: aLoginComponent
	loginComponent := aLoginComponent ! !

!TLRegisterComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/23/2010 14:56'!
password
	^pswd! !

!TLRegisterComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/10/2011 11:09'!
register
	self setRecaptchaComponent.
	self useRecaptchaInRegistrationForm ifTrue: [
		captchaVerified  :=  self verifyReCaptcha ].
	
	userExists := (self loginComponent authenticationManager usernameExists: self username)
						or: [ self loginComponent authenticationManager usernameIsPending: self username].
	
	
	passwordEmpty := pswd isEmptyOrNil and: [ loginComponent allowEmptyPassword not ].
	
	passwordsMatch := (pswd = confpswd).
	
	passwordValidationError := (loginComponent validateNewPassword: pswd).
	
	((userExists not) & captchaVerified & passwordsMatch & passwordValidationError isNil & passwordEmpty not)
		ifTrue: [ self answer: true ].! !

!TLRegisterComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/10/2011 10:43'!
renderContentOn: html

	html form
	 	onKeyUp: ('enableRegisterButton()');
		script: 'document.getElementById("registeruser").focus();';
	with: [
		html table: [
			userExists
				ifTrue: [
					html tableRow: [
						html tableData
							colSpan: 2;
							with: [
								html div
									class: 'registererror';
									id: 'registerusernameexists'; 
									with: 'That username is already taken. Try another.']]]
				ifFalse: [
					passwordsMatch 
					ifFalse:  [
						html tableRow: [
							html tableData
								colSpan: 2;
								with: [
									html div 
										class: 'registererror';
										id: 'registerpasswordmismatch'; 
										with: 'Password entries do not match. Try again.']]]
					ifTrue: [
					captchaVerified
						ifFalse:  [
							html tableRow: [
								html tableData
									colSpan: 2;
									with: [
										html div 
											class: 'registererror';
											id: 'registercaptchaincorrect'; 
											with: 'Captcha incorrect. Try again.']]]
						ifTrue: [
							passwordValidationError isNil
								ifFalse: [
									html tableRow: [
										html tableData
											colSpan: 2;
											with: [
												html div 
												class: 'registererror';
												id: 'registerpasswordinvalid'; 
													with: passwordValidationError ]]]
										
								ifTrue: [
									passwordEmpty
										ifTrue: [
											html tableRow: [
												html tableData
													colSpan: 2;
													with: [
														html div 
														class: 'registererror';
														id: 'registerpasswordempty'; 
															with: 'You must provide a password.' ]]]]]]].
			html tableRow: [
				html tableData: 'Username:'.
				html tableData: [
					html textInput
						id: 'registeruser';
						callback: [ :v | user := v ];
						with: user]].
			html tableRow: [
				html tableData: 'Password:'.
				html tableData: [
					html passwordInput
						id: 'registerpswd';
				 		callback: [ :v | pswd := v ];
						with: pswd ]].
			html tableRow: [
				html tableData: 'Confirm password:'.
				html tableData: [
					html passwordInput
						id: 'registerconfirmpswd';
				 		callback: [ :v | confpswd := v ];
						with: confpswd ]].
			html tableRow: [
				html tableData: 'Email:'.
				html tableData: [
					html textInput
						id: 'registeremail';					
				 		callback: [ :v | email := v ];
						with: email ]].

			self useRecaptchaInRegistrationForm ifTrue: [
				html tableRow: [
					html tableData 
						colSpan: 2;
						style: 'padding: 10px;';
						id: 'registercaptcha';
						with: captchaComponent]].
			html tableRow: [
				html tableData.
				html tableData: [
						html button
							disabled: true;
							id: 'registerbtn';
							callback: [ self register ];
							with: 'Register'.
						html button
							disabled: false;
							id: 'cancelbtn';
							callback: [ self cancel ];
							with: 'Cancel']]]]! !

!TLRegisterComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/31/2010 09:43'!
script
	^ self class script! !

!TLRegisterComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/7/2011 21:48'!
setRecaptchaComponent
	| recaptchaClass |
	captchaComponent := 
		((recaptchaClass := (Smalltalk at: #BWRecaptchaComponent ifAbsent: [ nil ])) isNil
		ifFalse: [ captchaComponent ifNil: [ recaptchaClass new ]]
		ifTrue: [ nil ])
! !

!TLRegisterComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/26/2010 09:43'!
useRecaptchaInRegistrationForm 
	^ self application preferenceAt: #useRecaptchaInRegistrationForm! !

!TLRegisterComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/23/2010 14:57'!
username
	^user! !

!TLRegisterComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/7/2011 20:39'!
verifyReCaptcha
	^ captchaComponent isNil
		ifFalse: [ captchaComponent verify ]
		ifTrue: [ true ]! !

WAComponent subclass: #TLRegistrationSubmitFailed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TF-Login'!

!TLRegistrationSubmitFailed methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/28/2010 20:10'!
renderContentOn: html

	html form
		class: 'regsubmitfailed';
		with: [ 
			html text: 'We failed trying to send your registration confirmation email.';
				break.
			html button
				callback: [ self answer ];
				with: 'Ok']! !

WAComponent subclass: #TLRegistrationSubmitted
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TF-Login'!

!TLRegistrationSubmitted methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/28/2010 20:09'!
renderContentOn: html

	html form
		class: 'regsubmitted';
		with: [ 
			html text: 'An email has been sent to the email address you povided that will allow you to confirm your registration.';
				break.
			html button
				callback: [ self answer ];
				with: 'Ok']! !

WAComponent subclass: #TLResetPasswordComponent
	instanceVariableNames: 'pendingPasswordReset username pswd usernameMatchError pswdconf passwordMatchError resetSuccessful loginComponent passwordValidationError passwordEmptyError'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TF-Login'!

!TLResetPasswordComponent class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 06:52'!
loginComponent: aLoginComponent pendingReset: aPendingReset
	^ self basicNew
		initialize;
		loginComponent: aLoginComponent;
		pendingPasswordReset: aPendingReset;
		yourself ! !

!TLResetPasswordComponent class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/10/2010 12:39'!
new: pendingReset
	^ self new pendingPasswordReset: pendingReset ! !

!TLResetPasswordComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/12/2011 11:05'!
initialize
	super initialize.
	resetSuccessful := nil.
	usernameMatchError := false.
	passwordMatchError := false.
	passwordEmptyError := false.
	passwordValidationError := nil.! !

!TLResetPasswordComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 06:55'!
loginComponent
	^ loginComponent ! !

!TLResetPasswordComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 06:55'!
loginComponent: aLoginComponent
	loginComponent := aLoginComponent ! !

!TLResetPasswordComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/9/2010 16:26'!
pendingPasswordReset
	^ pendingPasswordReset! !

!TLResetPasswordComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/9/2010 16:25'!
pendingPasswordReset: pendingReset
	pendingPasswordReset := pendingReset! !

!TLResetPasswordComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/12/2011 11:17'!
renderContentOn: html
	resetSuccessful notNil & resetSuccessful
		ifTrue: [
			html form
				class: 'pswdresetsuccessform';
				with: [
				html
					text: 'Password reset successful. Click Ok to log in.'.
				html button
						id: 'passwordresetsuccessokbtn';
						callback: [ self session redirectTo: (self session baseUrl) ];
						with: 'Ok']]
		ifFalse: [
			| warned |
			warned := false.
			html form
				class: 'passwordresetform';
				onKeyUp: ('enableResetButton();');
				script: 'document.getElementById("resetpswduser").focus();';
				with: [
					html span 
					class: 'resetpswdtitle';
					with: 'Password reset'.
					html break.
				html table: [
					usernameMatchError
						ifTrue:  [
							warned := true.
							html tableRow: [
								html tableData
									colSpan: 2;
									with: [
										html div
											id: 'resetpasswordusernamemismatch';
											class: 'resetpassworderror';
											with: 'Incorrect username. Try again.']]].
					warned not & passwordMatchError 
					ifTrue:  [
						warned := true.
						html tableRow: [
							html tableData
								colSpan: 2;
								with: [
									html div 
										id: 'resetpasswordmismatch';
										class: 'resetpassworderror';
										with: 'Password entries do not match. Try again.']]].
					warned not & passwordEmptyError
						ifTrue: [
							warned := true.
							html tableRow: [
								html tableData
									colSpan: 2;
									with: [
										html div
											id: 'resetpasswordempty';
											class: 'resetpassworderror'; 
											with: 'Password may not be empty.' ]]].
					warned not &  passwordValidationError notNil
						ifTrue: [
							warned := true.
							html tableRow: [
								html tableData
									colSpan: 2;
									with: [
										html div
											id: 'resetpasswordinvalid';
											class: 'resetpassworderror'; 
											with: passwordValidationError ]]].
					html tableRow: [
						html tableData: 'Username:'.
						html tableData: [
							html textInput
								value: username;
								id: 'resetpswduser';
								callback: [ :v | username := v ]]].
					html tableRow: [
						html tableData: 'New password:'.
						html tableData: [
							html passwordInput
								id: 'resetpswd';
				 				callback: [ :v | pswd := v ]]].
					html tableRow: [
						html tableData: 'New password confirm:'.
						html tableData: [
							html passwordInput
								id: 'resetpswdconfirm';
				 				callback: [ :v | pswdconf := v ]]].
					html tableRow: [
						html tableData.
						html tableData: [
							html button
								id: 'resetbtn';
								disabled: true;
								callback: [ self setNewPassword ];
								with: 'Set password']]]]]! !

!TLResetPasswordComponent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/12/2011 11:05'!
setNewPassword
	| user modifiedUser |
	
	usernameMatchError := username asLowercase ~= pendingPasswordReset username asLowercase.
	passwordMatchError := pswd ~= pswdconf.
	passwordValidationError := loginComponent validateNewPassword: pswd.
	passwordEmptyError := pswd isEmptyOrNil and: [ loginComponent allowEmptyPassword not ].
	usernameMatchError | passwordMatchError | passwordEmptyError | passwordValidationError notNil
		ifTrue: [ ^ self ]
		ifFalse: [
			user := self loginComponent authenticationManager userForUsername: username.
			modifiedUser := user copy.
			modifiedUser password: pswd.
			self loginComponent authenticationManager updateUser: modifiedUser.
			resetSuccessful := true ]! !

WAComponent subclass: #TLTestApp
	instanceVariableNames: 'loginComponent editingAccount editAccountComponent children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TF-Login'!

!TLTestApp commentStamp: '<historical>' prior: 0!
I am the test aplication for TFLogin.!

!TLTestApp class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/11/2011 16:56'!
initialize
	"TLTestApp initialize"

	| application |
	super initialize.
	application := WAAdmin register: self asApplicationAt: 'LoginTestApp'.
	application preferenceAt: #sessionClass put: TLSession.
	application configuration parents add: TLTestAppConfiguration instance.
	application configuration parents add: TLConfiguration instance.
	application configuration parents add: WAEmailConfiguration instance.
	(Smalltalk at: #BWRecaptchaConfiguration ifAbsent: [ nil ]) isNil ifFalse: [
		application configuration parents add: BWRecaptchaConfiguration instance].
	application preferenceAt: #smtpServer put: 'localhost'.
	application preferenceAt: #minimumPasswordLength put: 6.
	application preferenceAt: #maximumFailedLoginAttempts put: 3.
	application preferenceAt: #sendRegistrationConfirmationEmail put: false.
	application preferenceAt: #confirmationTimeoutMinutes put: 10.
	application preferenceAt: #useRecaptchaInRegistrationForm put: false.	
	application preferenceAt: #confirmEmailChangeViaEmail put: false.
	application preferenceAt: #confirmAccountChangesViaEmail put: false.
	application preferenceAt: #allowEmptyPasswords put: false.
	application preferenceAt: #allowUsernameChange put: false.
	application preferenceAt: #allowAutomaticLogin put: false.

! !

!TLTestApp methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 13:04'!
children
	^ children ifNil: [ children := Bag new ]! !

!TLTestApp methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/7/2011 12:12'!
confirmWithUser
	| url userAction |
		"Instantiate a TLPendingUserAction object for your user and
		provide a one-argument block to be evaluated when the user confirms."
		userAction := TLPendingUserAction 
			forUser: self session user
			onConfirmDo: [ :confirmedAction |
				"In our action we will log the user in and set a flag indicating that
				they have confirmed."
				loginComponent loginUserById: confirmedAction userId.
				self testConfirmed: true ].
	
		"Queue the pending user action. It will remain active for the configured
		confirmation timeout period. This method retruns the confirmation URL
		to which the user must navigate to confirm the action." 
		url := loginComponent addPendingUserAction: userAction.
	
		"Send a confirmation email to the user."
		self
			sendTestConfirmationUrl: url
			to: self session user email
			timeout: (self application preferenceAt: #confirmationTimeoutMinutes)	
		
! !

!TLTestApp methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/7/2011 09:25'!
deleteMe
	(self
		call: (WAYesOrNoDialog new
			addDecoration: (WAMessageDecoration new message: 'Really delete your Login Test App account and all its data?');
			yourself))
		ifTrue: [ loginComponent deleteLoggedInUser  ]
! !

!TLTestApp methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/7/2011 17:51'!
disableMe
	self session user applicationProperties at: 'disabled' put: (DateAndTime current) + 2 minutes.
	self loggedOut! !

!TLTestApp methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/8/2011 11:19'!
disabledForLoginFailuresText 
	^ 'Too many failed login attempts. Your account has been disabled for 2 minutes.' ! !

!TLTestApp methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 12:38'!
editingAccount 
	^ editingAccount ifNil: [ ^ false ]! !

!TLTestApp methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 12:38'!
editingAccount: aBoolean
	editingAccount  := aBoolean.
! !

!TLTestApp methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/3/2011 08:24'!
emailHost
	"Answer the server hostname."
	^ self session requestContext request host copyUpTo: $:.
! !

!TLTestApp methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/9/2011 08:23'!
initialRequest: aRequest
	super initialRequest: aRequest.
	loginComponent cookieLogin ! !

!TLTestApp methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/8/2011 09:51'!
initialize
	
	super initialize.
	loginComponent := TLLoginComponent appName: 'LoginTestApp'.
	loginComponent onAnswer: [ :user | user ifNotNilDo: [ : u | self loggedIn: u ] ].
	loginComponent passwordValidator: [ :pswd | self validatePassword: pswd ].
	loginComponent onLogin: [ :user | self loginFilter: user ].
	loginComponent onLoginFail: [ :username :address | self loginFailedUser: username from: address ].
	self children add: loginComponent.
	editAccountComponent := (TLEditAccountComponent loginComponent: loginComponent).
	editAccountComponent onAnswer: [ self editingAccount: false].
	self children add: editAccountComponent.
	self setMailSenders ! !

!TLTestApp methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/9/2011 12:58'!
loggedIn: user
	"sent from onAnswer in self initialize."

	| loginHistory |
	user applicationProperties removeKey: 'failedLoginAttempts' ifAbsent: [  ].
	loginHistory := user applicationProperties at: 'Login History' ifAbsentPut: [ TLTestAppLoginHistory new ].
	loginHistory list add: (TLTestAppLoginHistoryItem when: user lastLogin where: user lastLoginFrom).
	loginComponent saveUser! !

!TLTestApp methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/3/2011 08:48'!
loggedOut
	loginComponent logout.
! !

!TLTestApp methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/8/2011 11:32'!
loginFailedUser: username from: address
	"After the configured number of consecutive failed login attempts, disable the
	account for 2 minutes. Answer nil or text to be displayed in place of the normal
	authorization failure message."
	
	^ (loginComponent authenticationManager usernameExists: username)
		ifTrue: [
			| failedUser failureCount |
			failedUser := loginComponent authenticationManager userForUsername: username.
			failureCount := failedUser applicationProperties at: 'failedLoginAttempts' ifAbsent: [ 0 ].
			failureCount < self maximumFailedLoginAttempts
				ifTrue: [
					failedUser applicationProperties at: 'failedLoginAttempts' put: (failureCount  + 1).
					loginComponent saveUser: failedUser.
					nil ]
				ifFalse: [
					failedUser applicationProperties at: 'disabledForLoginFailures' put: (DateAndTime current) + 2 minutes.
					loginComponent saveUser: failedUser.
					self disabledForLoginFailuresText ]]
		ifFalse: [ nil ]! !

!TLTestApp methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/8/2011 11:34'!
loginFilter: user
	"Return nil to allow login, or text to be displayed to the user if login is disallowed.
	First we check for disable from login failures, then for user requested disable."
	
	^ (self loginFilterDisableForLoginFailures: user) ifNil: [self loginFilterDisabledByUser: user ]! !

!TLTestApp methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/8/2011 11:18'!
loginFilterDisableForLoginFailures: user
	"If logins have been disabled for too many login failures, return text to present to user,
	otherwise nil to allow login.
	
	Note that we use the same message here as is used in #loginFailedUser:from: so that
	there is no indication to the user that this time the correct password was actually entered." 

	| until |
	^ (user applicationProperties includesKey: 'disabledForLoginFailures')
		ifTrue: [
			until := user applicationProperties at: 'disabledForLoginFailures'.
			until < DateAndTime current
				ifTrue: [
					user applicationProperties removeKey: 'disabledForLoginFailures'.
				 	nil ]
				ifFalse: [
					self disabledForLoginFailuresText ]]
		ifFalse: [ nil ]! !

!TLTestApp methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/8/2011 11:15'!
loginFilterDisabledByUser: user
	"If the user has disabled logins, return text to be displayed. Otherwise nil to
	allow login."

	| until |
	^ (user applicationProperties includesKey: 'disabled')
		ifTrue: [
			until := user applicationProperties at: 'disabled'.
			until < DateAndTime current
				ifTrue: [
					user applicationProperties removeKey: 'disabled'.
					nil ]
				ifFalse: [
					'Your account is disabled. Try again later.']]
		ifFalse: [ nil ]! !

!TLTestApp methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/8/2011 11:12'!
maximumFailedLoginAttempts 
	^ self application preferenceAt: #maximumFailedLoginAttempts! !

!TLTestApp methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/8/2011 09:21'!
minimumPasswordLength
	^ self application preferenceAt: #minimumPasswordLength! !

!TLTestApp methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 12:24'!
renderAccountEditor: view

	view render: editAccountComponent! !

!TLTestApp methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/9/2011 12:43'!
renderContentOn: view

	view div
		class: 'hdr';
		with: 'Login Test App'.

		self renderPrefs: view.
	
		self renderTestConfirmation: view.

		self session user isNil 
			ifTrue: [
				view render: loginComponent ]
			ifFalse: [
				self editingAccount
				ifTrue: [
					self renderAccountEditor: view ]
				ifFalse: [
					self renderLoggedInContent: view]]

		
		
	
! !

!TLTestApp methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/8/2011 09:37'!
renderLoggedInContent: view
	view
		form: [ 
			view div
				class: 'loggedin';
				with: [ 
							view
								text: 'You are logged in.';
								break;
								text: 'Your username is ' , self session user username , '.';
								break;
								text: 'Your user ID is ' , self session user userId , '.';
								break;
								text: 'Your IP address is ' , self session user lastLoginFrom , '.';
								break;
								text: 'Login count: ' , self session user loginCount asString , '.';
								break;
								text: 'Your email address is ' , self session user email , '.'.
							view
								paragraph
									style: 'font-family: Helvetica, sans-serif; font-size: 10pt;';
									with: [ 
										view anchor
											callback: [ self editingAccount: true ];
											with: 'Edit Account Settings'.
							 			view text: ' | '.
										view anchor
											callback: [ self confirmWithUser ];
											with: 'Send a test confirmation email to me' .
							 			view text: ' | '.
										view anchor
											callback: [ self disableMe ];
											with: 'Disable my account for two minutes' .
							 			view text: ' | '.
										view anchor
											callback: [ self deleteMe ];
											with: 'Delete my account.'].
							view
								paragraph: [ 
									(view button)
										callback: [ self loggedOut ];
										with: 'Logout' ] ]]! !

!TLTestApp methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/9/2011 12:18'!
renderPrefs: view
		view form
			class: 'prefs';
			with: [
				view table: [
					view tableRow: [
						view tableData: [
							view checkbox
								submitOnClick;
								value: 	(self application preferenceAt: #sendRegistrationConfirmationEmail);
								callback: [ :v | 	self application preferenceAt: #sendRegistrationConfirmationEmail put: v ].
							view text: 'Registration requires email confirmation']].
					
					view tableRow: [
						view tableData: [
							view checkbox
								submitOnClick;
								value: 	(self application preferenceAt: #confirmEmailChangeViaEmail);
								callback: [ :v | 	self application preferenceAt: #confirmEmailChangeViaEmail put: v ].
							view text: 'Email address change requires email confirmation']].
					
					view tableRow: [
						view tableData: [
							view checkbox
								submitOnClick;
								value: 	(self application preferenceAt: #confirmAccountChangesViaEmail);
								callback: [ :v | 	self application preferenceAt: #confirmAccountChangesViaEmail put: v ].
							view text: 'All account changes require email confirmation']].
					
					view tableRow: [
						view tableData: [
							view checkbox
								submitOnClick;
								value: 	(self application preferenceAt: #allowEmptyPasswords);
								callback: [ :v | 	self application preferenceAt: #allowEmptyPasswords put: v ].
							view text: 'Allow passwords to be empty.']].
					
					view tableRow: [
						view tableData: [
							view checkbox
								submitOnClick;
								value: 	(self application preferenceAt: #allowUsernameChange);
								callback: [ :v | 	self application preferenceAt: #allowUsernameChange put: v ].
							view text: 'Allow users to change their usernames.']].
					
					view tableRow: [
						view tableData: [
							view checkbox
								submitOnClick;
								value: 	(self application preferenceAt: #allowRememberUsername);
								callback: [ :v |
									self application preferenceAt: #allowRememberUsername put: v ].
							view text: 'Allow users to remember their username in a cookie.']].

					view tableRow: [
						view tableData: [
							view checkbox
								submitOnClick;
								value: 	(self application preferenceAt: #allowAutomaticLogin);
								callback: [ :v | 
									self application preferenceAt: #allowAutomaticLogin put: v ].
							view text: 'Allow users to automatically log in.']].

					view tableRow: [
						view tableData: [
							view checkbox
								submitOnClick;
								value: 	(self application preferenceAt: #useRecaptchaInRegistrationForm);
								callback: [ :v | self application preferenceAt: #useRecaptchaInRegistrationForm put: v ].							
							view text: 'Include reCAPTCHA spam prevention in registration form']].

					view tableRow: [
						view tableData: [
							view text: 'Username/Password cookie expiration in days: '.
							view textInput
								style: 'width: 40px';
								value: (self application preferenceAt: #UsernamePasswordRememberDays);
								callback: [ :v | self application preferenceAt: #UsernamePasswordRememberDays put: v ].
							view button
								submitOnClick
								with: 'Set']].

					view tableRow: [
						view tableData: [
							view text: 'Confirmation email timeout in minutes: '.
							view textInput
								style: 'width: 40px';
								value: (self application preferenceAt: #confirmationTimeoutMinutes);
								callback: [ :v | self application preferenceAt: #confirmationTimeoutMinutes put: v ].
							view button
								submitOnClick
								with: 'Set']].
								.
					view tableRow: [
						view tableData: [
							view text: 'Minimum password length: '.
							view textInput
								style: 'width: 40px';
								value: (self application preferenceAt: #minimumPasswordLength);
								callback: [ :v | self application preferenceAt: #minimumPasswordLength put: v ].
							view button
								submitOnClick
								with: 'Set']].
						
					view tableRow: [
						view tableData: [
							view text: 'Maximum login failures before account disabled: '.
							view textInput
								style: 'width: 40px';
								value: (self application preferenceAt: #maximumFailedLoginAttempts);
								callback: [ :v | self application preferenceAt: #maximumFailedLoginAttempts put: v ].
							view button
								submitOnClick
								with: 'Set']].

					"view tableRow: [
						view tableData: [
							view text: 'SMTP server address: '.
							view textInput
								value: (self application preferenceAt: #outgoingMailServerAddress);
								callback: [ :v | self application preferenceAt: #outgoingMailServerAddress put: v ]]]."

					"view tableRow: [
						view tableData: [
							view text: 'reCAPTCHA Private Key: '.
							view textInput
								style: 'width: 300px';
								value: (self application preferenceAt: #privateKey);
								callback: [ :v | self application preferenceAt: #privateKey put: v ]]].
					view tableRow: [
						view tableData: [
							view text: 'reCAPTCHA Public Key: '.
							view textInput
								style: 'width: 300px';
								value: (self application preferenceAt: #publicKey);
								callback: [ :v | self application preferenceAt: #publicKey put: v ]]]."
					"
					view tableRow: [
						view tableData: [
							view checkbox.
							view text: 'Silently fail for 300 seconds after 3 failed attempts.']].
					
					view tableRow: [
						view tableData: [
							view checkbox.
							view text: 'Send email after 10 failed attempts.']].
					"					]]! !

!TLTestApp methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/9/2011 12:25'!
renderTestConfirmation: html
	self testConfirmed
		ifFalse: [ ^ self ].
	(html div)
		style: 'font-weight: 700; margin-left: 10px';
		with: 'Test confirmation received. You have been logged in.'.
	self testConfirmed: false! !

!TLTestApp methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/5/2011 10:02'!
sendAccountChangeConfirmationTo: email confirmUrl: url timeout: timo newUser: newUser
	"Compose and send email. Answer true on success, false on failure."
	
	| textBody htmlBody emailOk appName |
	
	appName := 'Login Test App'.
	
	textBody := (WriteStream on: String new)
		<< 'This email is in response to your request to make changes to your '; << appName; << ' account.'; crlf;crlf;
		<< 'Direct your browser to the following URL within ';<< timo asString; << ' minutes to confirm this change'; crlf;crlf;
		<< '         '; << url; crlf;crlf;
		<< 'If you did not request a change then this message may indicate a beak-in attempt at ';<< appName; <<'.'.	
	
	
	htmlBody := WAHtmlCanvas builder fullDocument: true; render: [ :html |
		html div
			style: 'font-size: 11pt;';
			with: [
				html div
					style: 'margin-bottom: 10px;';
					with: 'This email is in response to your request to make changes to your ', appName, ' account'.
				html text: 'Click on the link below within ', timo asString, ' minutes to confirm this change.'.
				html div
					style: 'margin-left:20pt;margin-top:10px;margin-bottom:10px;';
					with: [
						html anchor
							url: url;
							with: 'Confirm account changes'].
				html text: 'If the link above is unresponsive, copy and paste the URL below into your browser''s address field to confirm the change.'.
				html div	
					style: 'margin-left:20pt;margin-top:10px;margin-bottom:10px;';
					with: url.
				html text: 'If you did not request a change then this message may indicate a beak-in attempt at ', appName, '.']].

	(emailOk := self sendEmailTo: email subject:  appName, ' account changes - action required' text: textBody html: htmlBody)
		ifFalse: [ Transcript cr; show: url ].
	
	^ emailOk
! !

!TLTestApp methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/5/2011 10:02'!
sendEmailChangeConfirmationTo: email confirmUrl: url timeout: timo newUser: newUser
	"Compose and send email. Answer true on success, false on failure."
 
	| textBody htmlBody emailOk appName |
	
	appName := 'Login Test App'.
	
	textBody := (WriteStream on: String new)
		<< 'This email is in response to your request change your '; << appName; << ' email address.'; crlf;crlf;
		<< 'Direct your browser to the following URL within ';<< timo asString; << ' minutes to confirm this change'; crlf;crlf;
		<< '         '; << url; crlf;crlf;
		<< 'If you did not request an address change then this message may indicate a beak-in attempt at ';<< appName; <<'.'.		
	
	htmlBody := WAHtmlCanvas builder fullDocument: true; render: [ :html |
		html div
			style: 'font-size: 11pt';
			with: [
			html div
				style: 'margin-bottom: 10px;';
				with: 'This email is in response to your request change your ', appName, ' email address'.
			html text: 'Click on the link below within ', timo asString, ' minutes to confirm this change.'.
			html div
				style: 'margin-left:20pt;margin-top:10px;margin-bottom:10px;';
				with: [
					html anchor
						url: url;
						with: 'Confirm address change'].
			html text: 'If the link above is unresponsive, copy and paste the URL below into your browser''s address field to confirm the change.'.
			html div	
				style: 'margin-left:20pt;margin-top:10px;margin-bottom:10px;';
				with: url.
			html text: 'If you did not request a change then this message may indicate a beak-in attempt at ', appName, '.']].

	(emailOk := self sendEmailTo: email subject:  appName, ' email address change - action required' text: textBody html: htmlBody)
		ifFalse: [ Transcript cr; show: url ].
	
	^ emailOk
! !

!TLTestApp methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/6/2011 12:27'!
sendEmailTo: toAddress subject: subj text: textBody html: htmlBody
	"Send multi-part MIME email message."
	
	| sem em|
	em := TLMailMessage empty.
	em addAlternativePart: textBody contents contentType: 'text/plain'.
	em addAlternativePart: htmlBody contents contentType: 'text/html'.
	sem := em
		seasideMailMessageFrom: 'Registrar@' , self emailHost
		to: toAddress
		subject: subj.
	[sem send] on: Exception do: [ :ex | ^ false ].
	^ true! !

!TLTestApp methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/5/2011 10:01'!
sendPasswordResetUrl: url to: email  timeout: timo
	"Compose and send email. Answer true on success, false on failure."

	| textBody htmlBody emailOk appName |
	
	appName := 'Login Test App'.
	
	textBody := (WriteStream on: String new)
		<< 'This email is in response to your request reset your '; << appName; << ' password.'; crlf;crlf;
		<< 'Direct your browser to the following URL within ';<< timo asString; << ' minutes to reset your password.'; crlf;crlf;
		<< '         '; << url; crlf;crlf;
		<< 'If you did not request a password reset then this message may indicate a beak-in attempt at ';<< appName; <<'.'.		
	
	htmlBody := WAHtmlCanvas builder fullDocument: true; render: [ :html |
		html div
			style: 'font-size:11pt;';
			with: [		
				html span
					style: 'margin-bottom: 10px;';
					with: 'This email is in response to your request to reset your ', appName, ' password.'.
			html text: 'Click on the link below within ', timo asString, ' minutes to reset your password.'.
			html div
				style: 'margin-left:20pt;margin-top:10px;margin-bottom:10px;';
				with: [
					html anchor
						url: url;
						with: 'Password Reset'].
			html text: 'If the link above is unresponsive, copy and paste the URL below into your browser''s address field to reset your password.'.
			html div
				style: 'margin-left:20pt;margin-top:10px;margin-bottom:10px;';
				with: url.
			html text: 'If you did not request a password reset then this message may indicate a beak-in attempt at ', appName, '.']].

	(emailOk := self sendEmailTo: email subject:  appName, ' password reset' text: textBody html: htmlBody)
		ifFalse: [ Transcript cr; show: url ].

	^ emailOk
 ! !

!TLTestApp methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/5/2011 10:01'!
sendRegistrationConfirmationEmailTo: email confirmUrl: url timeoutMinutes: timo
	"Compose and send email. Answer true on success, false on failure."

	| textBody htmlBody emailOk appName |

	appName := 'Login Test App'.
	
	textBody := (WriteStream on: String new)
		<< 'This email is in response to your request to register at '; << appName; << '.'; crlf;crlf;
		<< 'Direct your browser to the following URL within ';<< timo asString; << ' minutes to confirm your registration.'; crlf;crlf;
		<< '         '; << url; crlf;crlf;
		<< 'If you did not attempt to register for a'; << appName; << ' account then this message was sent in error and should be ignored.'.	

	htmlBody := WAHtmlCanvas builder fullDocument: true; render: [ :html |
		html div
			style: 'font-size:11pt;';
			with: [
				html div
					style: 'margin-bottom: 10px;';
					with: 'This email is in response to your request to register at ', appName, '.'.
				html text: 'Click on the link below within ', timo asString, ' minutes to confirm your registration.'.
				html div
					style: 'margin-left:20pt;margin-top:10px;margin-bottom:10px;';
					with: [
						html anchor
							url: url;
							with: 'Confirm registration'].
		 		html text: 'If the link above is unresponsive, copy and paste the URL below into your browser''s address field to confirm your registration.'.
				html div
					style: 'margin-left:20pt;margin-top:10px;margin-bottom:10px;';
					with: url.
				html text: 'If you did not attempt to register for a', appName, ' account then this message was sent in error and should be ignored.']].

	(emailOk := self sendEmailTo: email subject:  appName, ' Registration - action required' text: textBody html: htmlBody)
		ifFalse: [ Transcript cr; show: url ].

	^ emailOk

	! !

!TLTestApp methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/7/2011 14:48'!
sendTestConfirmationUrl: url to: email  timeout: timo
	"Compose and send email. Answer true on success, false on failure."

	| textBody htmlBody emailOk appName |
	
	appName := 'Login Test App'.
	
	textBody := (WriteStream on: String new)
		<< 'This email is in response to your request to receive a test confirmation email from ';<< appName;<< '.'; crlf;crlf;
		<< 'Direct your browser to the following URL within ';<< timo asString; << ' minutes to confirm your receipt of this message.'; crlf;crlf;
		<< '         '; << url; crlf;crlf;
		<< 'If you did not request a test confirmation email then this message may indicate someone else has access to your account at ';<< appName; <<'.'.		
	
	htmlBody := WAHtmlCanvas builder fullDocument: true; render: [ :html |
		html div
			style: 'font-size:11pt;';
			with: [		
				html span
					style: 'margin-bottom: 10px;';
					with: 'This email is in response to your request to receive a test confirmation email from ', appName, '.'.
			html text: ' Click on the link below within ', timo asString, ' minutes to confirm your receipt of this message.'.
			html div
				style: 'margin-left:20pt;margin-top:10px;margin-bottom:10px;';
				with: [
					html anchor
						url: url;
						with: 'Confirm'].
			html text: 'If the link above is unresponsive, copy and paste the URL below into your browser''s address field to reset your password.'.
			html div
				style: 'margin-left:20pt;margin-top:10px;margin-bottom:10px;';
				with: url.
			html text: 'If you did not request a test confirmation email then this message may indicate someone else has access to your account at ', appName, '.']].

	(emailOk := self sendEmailTo: email subject:  appName, ' test confirmation email' text: textBody html: htmlBody)
		ifFalse: [ Transcript cr; show: url ].

	^ emailOk
 ! !

!TLTestApp methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/5/2011 10:01'!
sendUsernameReminderFor: usernames to: email
	"Compose and send email. Answer true on success, false on failure."

	|  textBody htmlBody emailOk appName |
	
	appName := 'Login Test App'.
	
	textBody := (WriteStream on: String new)
		<< 'This email is in response to your request to be reminded of the '; << appName; << 'usernames registered with the email address ';
		<< email; crlf; crlf;
		<< 'The following usernames are registered with the abovementioned email address'; crlf;crlf.
	usernames do: [ :each |
		textBody << '         ' << each; crlf ].
	textBody crlf;crlf;
		<< 'If you did not request a username reminder then this message may indicate a beak-in attempt at '; << appName; << '.'..	
	
	htmlBody := WAHtmlCanvas builder fullDocument: true; render: [ :html |
		html div
			style: 'font-size:11pt;';
			with: [
				html div
					style: 'margin-bottom: 10px;';
					with: 'This email is in response to your request to be reminded of the ', appName, ' usernames registered with the email address ', email,  '.'.
				html text: 'The following usernames are registered with the abovementioned email address.'.
				html div
					style: 'font-weight: 700; margin-left:20pt; margin-top:10px;margin-bottom:10px;';
					with: [
						usernames do: [ :each |
							html text: each; break ]].
				html text: 'If you did not request a username reminder then this message may indicate a beak-in attempt at ', appName, '.']].

	(emailOk := self sendEmailTo: email subject:  appName, ' username reminder' text: textBody html: htmlBody)
		ifFalse: [ Transcript cr; show: usernames ].

	^ emailOk
! !

!TLTestApp methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 12:36'!
setMailSenders
	loginComponent registrationConfirmationEmailSender: [ :url :email :timeout | 
		self
			sendRegistrationConfirmationEmailTo: email
			confirmUrl: url
			timeoutMinutes: timeout  ].
	loginComponent passwordResetEmailSender: [ :url :email :timeout |
		self
			sendPasswordResetUrl: url
			to: email
			timeout: timeout ].
	loginComponent usernameReminderEmailSender: [ :usernames :email | 
		self
			sendUsernameReminderFor: usernames
			to: email ].
	editAccountComponent emailChangeConfirmationEmailSender: [ :url :email :timeout :newUser |
		self
			sendEmailChangeConfirmationTo: email
			confirmUrl: url
			timeout: timeout
			newUser: newUser  ].
	editAccountComponent accountChangeConfirmationEmailSender: [ :url :email :timeout :newUser |
		self
			sendAccountChangeConfirmationTo: email
			confirmUrl: url
			timeout: timeout
			newUser: newUser ].

	
	
! !

!TLTestApp methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/29/2010 21:22'!
style
	^'
	.hdr { font-size: 18pt; font-weight: 700; color: #404080; padding: 10px 10px 20px 10px; }
	
	.prefs { padding: 10px; margin-bottom: 20px; margin-left: 10px; border: 1px solid #404080; width: 700px; }
	
	.logregform { padding: 10px; }
	
	.autherror { padding: 20px 10px 20px 10px; color: darkred; }
	
	.loginform { padding: 10px; }
	
	.loggedin { padding: 10px }
	
	.regsubmitfailed { padding: 20px 10px 20px 10px; color: darkred; }
	
	'! !

!TLTestApp methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/7/2011 20:58'!
testConfirmed
	self session user ifNil: [ ^ false ].	
	^ self session user applicationProperties at: 'TestConfirmed' ifAbsent: [ false ]! !

!TLTestApp methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/8/2011 02:10'!
testConfirmed: aBoolean
	self session user isNil ifFalse: [
		self session user applicationProperties at: 'TestConfirmed' put: aBoolean]! !

!TLTestApp methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/9/2011 11:54'!
updateRoot: aWAHtmlRoot
	super updateRoot: aWAHtmlRoot.
	aWAHtmlRoot title: 'Login Test App' translated! !

!TLTestApp methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/6/2011 19:49'!
validatePassword: password
	^ password size < self minimumPasswordLength 
		ifTrue: [ 'Password must be at least ', self minimumPasswordLength asString, ' characters long.']
		ifFalse: [ nil ]! !

WAComponent subclass: #TLTester
	instanceVariableNames: 'loginComponent editAccountComponent children loggedIn'
	classVariableNames: 'AllowEmptyPasswords ConfirmationTimeoutMinutes PasswordResetEmailSender RegistrationConfirmationEmailSender SendRegistrationConfirmationEmail SetLoginFailhander SetLoginFilter Testing UsernameReminderEmailSender'
	poolDictionaries: ''
	category: 'TF-Login'!

!TLTester class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/10/2011 11:01'!
allowEmptyPasswords
	^ AllowEmptyPasswords ifNil: [ false ]! !

!TLTester class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/10/2011 11:02'!
allowEmptyPasswords: aBoolean
	AllowEmptyPasswords := aBoolean! !

!TLTester class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/10/2011 08:02'!
appName
	^ 'TLTester'! !

!TLTester class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/10/2011 11:42'!
confirmationTimeoutMinutes
	^ ConfirmationTimeoutMinutes ifNil: [ 10 ]! !

!TLTester class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/10/2011 11:41'!
confirmationTimeoutMinutes: aNumber
	ConfirmationTimeoutMinutes := aNumber! !

!TLTester class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/10/2011 10:21'!
initialize

	| application |
	self testing ifFalse: [ ^ self ].
	super initialize.
	application := WAAdmin register: self asApplicationAt: self appName.
	application preferenceAt: #sessionClass put: TLSession.
	application configuration parents add: TLConfiguration instance.
	application configuration parents add: WAEmailConfiguration instance.
	application configuration parents add: BWRecaptchaConfiguration instance.
	application preferenceAt: #smtpServer put: 'localhost'.
	application preferenceAt: #sendRegistrationConfirmationEmail put: false.
	application preferenceAt: #confirmationTimeoutMinutes put: 10.
	application preferenceAt: #useRecaptchaInRegistrationForm put: false.	
	application preferenceAt: #confirmEmailChangeViaEmail put: false.
	application preferenceAt: #confirmAccountChangesViaEmail put: false.
	application preferenceAt: #allowEmptyPasswords put: false.
	application preferenceAt: #allowUsernameChange put: false.
	application preferenceAt: #allowAutomaticLogin put: false.

! !

!TLTester class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/11/2011 19:57'!
passwordResetEmailSender
	^ PasswordResetEmailSender ifNil: [ [ :url :email :timeout | ] ]! !

!TLTester class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/11/2011 19:58'!
passwordResetEmailSender: aThreeArgBlock
	PasswordResetEmailSender := aThreeArgBlock ! !

!TLTester class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/10/2011 11:17'!
registrationConfirmationEmailSender
	^ RegistrationConfirmationEmailSender ifNil: [ [ :url :email :timeout | ] ]! !

!TLTester class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/10/2011 11:17'!
registrationConfirmationEmailSender: aThreeArgBlock
	RegistrationConfirmationEmailSender := aThreeArgBlock ! !

!TLTester class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/10/2011 11:19'!
sendRegistrationConfirmationEmail 
	^ SendRegistrationConfirmationEmail ifNil: [ false ]! !

!TLTester class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/10/2011 11:19'!
sendRegistrationConfirmationEmail: aBoolean
	SendRegistrationConfirmationEmail := aBoolean ! !

!TLTester class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/12/2011 21:13'!
setLoginFailHandler
	^ SetLoginFailhander ifNil: [ ^ false ]! !

!TLTester class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/12/2011 21:14'!
setLoginFailHandler: aBoolean
	SetLoginFailhander := aBoolean ! !

!TLTester class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/12/2011 21:03'!
setLoginFilter
	^ SetLoginFilter ifNil: [ ^ false ]! !

!TLTester class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/12/2011 21:03'!
setLoginFilter: aBoolean
	SetLoginFilter  := aBoolean ! !

!TLTester class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/10/2011 10:23'!
setPasswordValidator
	^ SetPasswordValidator ifNil: [ ^ false ]! !

!TLTester class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/10/2011 10:23'!
setPasswordValidator: aBoolean
	SetPasswordValidator := aBoolean ! !

!TLTester class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/10/2011 09:59'!
testing
	^ Testing ifNil: [ ^false ]! !

!TLTester class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/10/2011 10:00'!
testing: aBoolean
	Testing := aBoolean ! !

!TLTester class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/10/2011 09:55'!
uninitialize

	WAAdmin unregister: self appName.
	Testing := nil.

! !

!TLTester class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/10/2011 13:42'!
usernameReminderEmailSender
	^ UsernameReminderEmailSender ifNil: [ [ :usernames :email | ] ]! !

!TLTester class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/10/2011 13:42'!
usernameReminderEmailSender: aTwoArgBlock
	UsernameReminderEmailSender := aTwoArgBlock ! !

!TLTester methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/10/2011 08:10'!
children
	^ children ifNil: [ children := Bag new ]! !

!TLTester methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/10/2011 08:09'!
initialRequest: aRequest
	super initialRequest: aRequest.
	loginComponent cookieLogin ! !

!TLTester methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/13/2011 09:34'!
initialize
	
	super initialize.
	self application preferenceAt: #allowEmptyPasswords put: self class allowEmptyPasswords.
	self application preferenceAt: #sendRegistrationConfirmationEmail put: self class sendRegistrationConfirmationEmail. 
	self application preferenceAt: #confirmationTimeoutMinutes put: self class confirmationTimeoutMinutes. 
	loginComponent := TLLoginComponent appName: self class appName.
	loginComponent onAnswer: [ :user | user ifNotNilDo: [ : u |  ] ].
	self class setPasswordValidator ifTrue: [
		loginComponent passwordValidator: [ :pswd |  pswd size < 6 ifTrue: [ 'password too short'] ifFalse: [ nil ] ] ].
	self class setLoginFilter ifTrue: [
		loginComponent onLogin: [ :user |  
			user loginCount > 5
				ifTrue: [ 'Too many logins' ]
				ifFalse: [
					(user applicationProperties at: 'failcount' ifAbsent: [0]) >= 3
						ifTrue: [ 'Account disabled.']
						ifFalse: [ nil ]]]].
	self class setLoginFailHandler ifTrue: [
		loginComponent onLoginFail: [ :username :address |
			| user failcount |  
			user := loginComponent authenticationManager userForUsername: username.
			failcount := user applicationProperties at: 'failcount' ifAbsent: [ 0 ].
			failcount := failcount + 1.
			user applicationProperties at: 'failcount' put: failcount.
			loginComponent saveUser: user.
			nil ]].
	self children add: loginComponent.
	editAccountComponent := (TLEditAccountComponent loginComponent: loginComponent).
	editAccountComponent onAnswer: [ ].
	self children add: editAccountComponent.
	self setMailSenders.
	loggedIn := false.! !

!TLTester methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/12/2011 09:20'!
renderContentOn: html

	self session user isNil 
		ifTrue: [
			html render: loginComponent ]
		ifFalse: [
			html form
				class: 'loggedinform';
				with: [
					html button
						id: 'logoutbtn';
						callback: [ loginComponent logout ];
						with: 'Logout']]! !

!TLTester methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/10/2011 13:41'!
setMailSenders
	loginComponent registrationConfirmationEmailSender: [ :url :email :timeout |  self class registrationConfirmationEmailSender value: url value: email value: timeout ].
	loginComponent passwordResetEmailSender: [ :url :email :timeout | self class passwordResetEmailSender value: url value: email value: timeout ].
	loginComponent usernameReminderEmailSender: [ :usernames :email | self class usernameReminderEmailSender value: usernames value: email ].
	editAccountComponent emailChangeConfirmationEmailSender: [ :url :email :timeout :newUser | ].
	editAccountComponent accountChangeConfirmationEmailSender: [ :url :email :timeout :newUser | ].
! !

!TLTester methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/10/2011 08:14'!
updateRoot: aWAHtmlRoot
	super updateRoot: aWAHtmlRoot.
	aWAHtmlRoot title: self class appName! !

WAComponent subclass: #TLUsernameEmailSent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TF-Login'!

!TLUsernameEmailSent methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/10/2011 13:38'!
renderContentOn: html
	html form
		class: 'usernameemailsent';
		with: [ 
			html div: 'Usernames registered with the email address you provided, if any, have been sent to the email address.'.
			html button
				id: 'usernameemailsentokbtn';
				callback: [ self answer ];
				with: 'Ok']! !

TestCase subclass: #TLAuthenticationManagerTest
	instanceVariableNames: 'authenticationManager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TF-Login'!

!TLAuthenticationManagerTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/2/2011 21:38'!
setUp
	authenticationManager := TLAuthenticationManager name: self name.
	! !

!TLAuthenticationManagerTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/2/2011 21:38'!
tearDown
	authenticationManager storageAdaptor deleteDatabase.
	! !

!TLAuthenticationManagerTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/2/2011 21:38'!
testAddAndGetUser
	authenticationManager addUser: (TLPendingUser username: 'User1' password: 'pswd1' email: 'user1@emailaddress').
	
	self deny: ( (authenticationManager getUser: 'User1' password: 'pswd1' ifAbsent: [ nil ]) isNil).

	self assert: ( (authenticationManager getUser: 'User1' password: 'badpswd' ifAbsent: [ nil ]) isNil) 
	! !

!TLAuthenticationManagerTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/9/2011 12:41'!
testCaseBlindness

	authenticationManager addUser: (TLPendingUser username: 'User1' password: 'pswd1' email: 'user1@emailaddress').
	
	self assert: (authenticationManager usernameExists: 'USER1').	

	self assert: ( (authenticationManager getUser: 'USER1' password: 'pswd1' ifAbsent: [ nil ]) notNil) 

! !

!TLAuthenticationManagerTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/2/2011 21:38'!
testLoginUser
	| u |

	authenticationManager addUser: (TLPendingUser username: 'User1' password: 'pswd1' email: 'user1@emailaddress').
	
	u := authenticationManager loginUser: 'User1' password: 'pswd1' from: '127.0.0.1'.

	self assert: (u lastLoginFrom = '127.0.0.1').	
	self deny: (u lastLogin isNil).
	self assert: (u lastLogin <= DateAndTime now).	

! !

!TLAuthenticationManagerTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/9/2011 12:41'!
testUsernameExists

	authenticationManager addUser: (TLPendingUser username: 'User1' password: 'pswd1' email: 'user1@emailaddress').
	
	self assert: (authenticationManager usernameExists: 'User1').	

! !

TestCase subclass: #TLFileDataBaseTest
	instanceVariableNames: 'items db'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TF-Login'!

!TLFileDataBaseTest commentStamp: '<historical>' prior: 0!
Simple file database. One versioned file is maintained.!

!TLFileDataBaseTest methodsFor: 'private' stamp: 'TonyFleig 12/30/2010 11:25'!
baseFileName
	^ 'FileDbEntry'! !

!TLFileDataBaseTest methodsFor: 'private' stamp: 'TonyFleig 12/30/2010 11:24'!
directoryName
	^ 'FileDbTest'! !

!TLFileDataBaseTest methodsFor: 'private' stamp: 'TonyFleig 12/30/2010 11:27'!
fileDatabaseGet
	^ items! !

!TLFileDataBaseTest methodsFor: 'private' stamp: 'TonyFleig 12/30/2010 11:27'!
fileDatabasePut: anObject
	items := anObject! !

!TLFileDataBaseTest methodsFor: 'setup-and-teardown' stamp: 'TonyFleig 1/1/2011 07:40'!
setUp
	items := OrderedCollection new.
	items add: '1'.
	items add: '2'.
	items add: '3'.
	
	db := FileDatabase source: self directoryName: self directoryName baseFileName: self baseFileName.
	
	! !

!TLFileDataBaseTest methodsFor: 'setup-and-teardown' stamp: 'TonyFleig 12/31/2010 13:03'!
tearDown
	db deleteDatabase! !

!TLFileDataBaseTest methodsFor: 'tests' stamp: 'TonyFleig 12/31/2010 13:27'!
testFilenameWithNumber
	db deleteDatabase.
	db save.
	db baseFileName: 'FileDbEntry2'.
	db save.
	db maxEntryCount: 3.
	db save.
	db save.
	db save.
	self assert: (db storageDirectory entries size = 4).
	db save.
	db save.
	db baseFileName: 'FileDbEntry'.
	db save.
	db save.
	db save.
	db save.
	self assert: (db storageDirectory entries size = 6).
! !

!TLFileDataBaseTest methodsFor: 'tests' stamp: 'TonyFleig 12/30/2010 11:42'!
testHistoryCount
	
	db maxEntryCount: 3.
	1 to: 6 do: [ :n |  db save ].
	self assert: (db storageDirectory entries size = 3).
	
	db maxEntryCount:  10.
	1 to: 8 do: [ :n |
		db save.
		self assert: (db storageDirectory entries size <= 10)].
	
! !

!TLFileDataBaseTest methodsFor: 'tests' stamp: 'TonyFleig 12/31/2010 13:03'!
testMultiple
	db deleteDatabase.
	db save.
	db baseFileName: 'FileDbEntryX'.
	db save.
	db maxEntryCount: 3.
	db save.
	db save.
	db save.
	self assert: (db storageDirectory entries size = 4)! !

!TLFileDataBaseTest methodsFor: 'tests' stamp: 'TonyFleig 1/9/2011 12:09'!
testSaveAndRestore
	self assert: items size = 3.
	db save.
	items removeAll.
	self assert: items isEmpty.
	db restore.
	self assert: items size = 3.
	items add: '4'.
	db restore.
	self assert: items size = 3.
	items add: '4'.
	db save.
	items removeAt: 1.
	self assert: items size = 3.
	db restore.
	self assert: items size = 4.
	

	! !

TestCase subclass: #TLFileStorageAdaptorTest
	instanceVariableNames: 'db'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TF-Login'!

!TLFileStorageAdaptorTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/2/2011 21:11'!
setUp
	db := TLFileStorageAdaptor  name: 'LoginDefaultStorageAdaptorTestDb'.

	! !

!TLFileStorageAdaptorTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/5/2011 12:12'!
tearDown
	db deleteDatabase.! !

!TLFileStorageAdaptorTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/5/2011 11:11'!
testCRUD

	| u1 u1a |

	"Create"
	db createUser: (TLRegisteredUser username: 'User1' password:  'pswd1' email: 'user1@emailaddress').
	db createUser: (TLRegisteredUser username: 'User2' password:  'pswd2' email: 'user2@emailaddress').
	db createUser: (TLRegisteredUser username: 'User3' password:  'pswd3' email: 'user3@emailaddress').

	self assert: ((db userForUsername:  'User1' ) email = 'user1@emailaddress' ).
	self assert: ((db userForUsername:  'User2' ) email = 'user2@emailaddress' ).
	self assert: ((db userForUsername:  'User3' ) email = 'user3@emailaddress' ).
	self assert: ((db userForUsername:  'User4' ) isNil ).

	"Fetches"
	self assert: (db userForUsername: 'User1') email = 'user1@emailaddress'.
	self assert: (db usersForEmail: 'user1@emailaddress') size = 1.
	self assert: ((db usersForEmail: 'user1@emailaddress') anySatisfy: [ :each | each username = 'User1' ]).

	"Verify multiple users with same email address."	
	u1 := (db usersForEmail: 'user1@emailaddress') anyOne.
	u1 email: 'user2@emailaddress'.
	db updateUser: u1.
	self assert: (db usersForEmail: 'user2@emailaddress') size = 2..
	self assert: ((db usersForEmail: 'user2@emailaddress') anySatisfy: [ :each | each username = 'User1' ]).
	self assert: ((db usersForEmail: 'user2@emailaddress') anySatisfy: [ :each | each username = 'User2' ]).
	u1 email: 'user1@emailaddress'.
	db updateUser: u1.

	"Update"
	u1 := (db userForUsername: 'User1') copy.
	u1a := u1 copy.
	u1a email: 'user1@newemailaddress'.
	u1a password: 'newpswd1'.
	u1a username: 'User1a'.

	self assert: ((db userForUsername:  'User1') email = 'user1@emailaddress' ).

	db updateUser:  u1a.
	
	self assert: ((db userForUsername: 'User1a') email = 'user1@newemailaddress' ).

	"Delete"
	db deleteUser: u1a.
	self assert: ((db userForUsername:  'User1a' ) isNil ).
	self assert: ((db userForUsername:  'User2' ) email = 'user2@emailaddress' ).
	self assert: ((db userForUsername:  'User3' ) email = 'user3@emailaddress' ).

	"Verify that database files are being created."
	self assert: (db fileCount > 0).! !

!TLFileStorageAdaptorTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/2/2011 21:13'!
testCaseBlindness
	db createUser: (TLRegisteredUser username: 'User1' password:  'pswd1' email: 'user1@emailaddress').
	
	self assert: ((db userForUsername: 'User1' ) email = 'user1@emailaddress' ).
	self assert: ((db userForUsername:  'user1') email = 'user1@emailaddress' ).
	
	self assert: ((db userForUsername:  'user11') isNil ).
	
	self assert: (db usernameExists: 'USER1').! !

!TLFileStorageAdaptorTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/9/2011 12:42'!
testChangeUsername
	"Make sure old files with the previous username are versioned appropriately."
	
	| u1 |

	db maxVersions: 4.

	db createUser: (TLRegisteredUser username: 'User1' password:  'pswd1' email: 'user1@emailaddress').
	db createUser: (TLRegisteredUser username: 'User2' password:  'pswd2' email: 'user2@emailaddress').

	u1 := db userForUsername: 'User1'.
	
	self assert: db fileCount = 2. "1 User1, 1 user2"
	
	db updateUser: u1.
	db updateUser: u1.
	
	self assert: db fileCount = 4. "Add 2 User1"
	
	db updateUser: u1.
	db updateUser: u1.

	self assert: db fileCount = 5. "Add 2 User1 and trim one."
	
	u1 username: 'User3'.
	db updateUser: u1.
	
	self assert: db fileCount = 5. "Add 1 User1 and trim one."

	db updateUser: u1.
	db updateUser: u1.
	db updateUser: u1.
	db updateUser: u1.

	self assert: db fileCount = 5. "Add 1 User1 and trim one."
! !

TestCase subclass: #TLMailMessageTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TF-Login'!

!TLMailMessageTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/9/2011 12:09'!
testMultiPartAlternative
	| m txt html  part1 part2 |
	
	txt := 'This is plain text.'.
	html :=  '<html><head></head><body>This is html.</body></html>'.
	
	m := TLMailMessage empty.
	m addAlternativePart: txt contentType: 'text/plain'. 
	m addAlternativePart: html contentType: 'text/html'.

	self assert: (((m fields at: 'content-type') at: 1) mainValue asLowercase = 'multipart/alternative'). 
	self assert: (m parts size = 2).

	part1 := m parts at: 1.
	part2 := m parts at: 2.

	self assert: ((part1 fields at: 'content-type') first mainValue asLowercase = 'text/plain').
	self assert: ((part1 body content) = txt).
	
	self assert: ((part2 fields at: 'content-type') first mainValue asLowercase = 'text/html').
	self assert: ((part2 body content) = html).
! !

!TLMailMessageTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/9/2011 12:09'!
testMultiPartMixed
	| m txt html  part1 part2 |
	
	txt := 'This is plain text.'.
	html :=  '<html><head></head><body>This is html.</body></html>'.
	
	m := TLMailMessage empty.
	m addMixedPart: txt contentType: 'text/plain'. 
	m addMixedPart: html contentType: 'text/html'.

	self assert: (((m fields at: 'content-type') at: 1) mainValue asLowercase = 'multipart/mixed'). 
	self assert: (m parts size = 2).

	part1 := m parts at: 1.
	part2 := m parts at: 2.

	self assert: ((part1 fields at: 'content-type') first mainValue asLowercase = 'text/plain').
	self assert: ((part1 body content) = txt).
	
	self assert: ((part2 fields at: 'content-type') first mainValue asLowercase = 'text/html').
	self assert: ((part2 body content) = html).
! !

!TLMailMessageTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/9/2011 12:10'!
testMultipart
	
	| m sm m2 part1 part2 txt html fromAddr toAddr subj |

	txt := 'This is plain text.'.
	html :=  '<html><head></head><body>This is html.</body></html>'.
	fromAddr := 'user1@address'.
	toAddr := 'user2@address'.
	subj := 'Test subject'.
	
	"Construct a multipart/alternative email message."
	m := TLMailMessage empty.
	m addAlternativePart: txt contentType: 'text/plain'. 
	m addAlternativePart: html contentType: 'text/html'.

	"Make it into a Seaside email message."
	sm := m seasideMailMessageFrom: fromAddr to: toAddr subject: subj.
	
	"Parse the Seaside message text into a MailMessage for testing."
	m2 := TLMailMessage from: sm plainMessage.

	self assert: (m2 from = fromAddr).
	self assert: (m2 to = toAddr).
	self assert: (m2 subject = subj).
	
	self assert: (((m2 fields at: 'content-type') at: 1) mainValue asLowercase = 'multipart/alternative'). 
	self assert: (m2 parts size = 2).

	part1 := m2 parts at: 1.
	part2 := m2 parts at: 2.

	self assert: ((part1 fields at: 'content-type') first mainValue asLowercase = 'text/plain').
	self assert: (part1 body content trimBoth = txt).
	
	self assert: ((part2 fields at: 'content-type') first mainValue asLowercase = 'text/html').
	self assert: (part2 body content trimBoth  = html).
	
! !

TestCase subclass: #TLMultiFileDatabaseTest
	instanceVariableNames: 'db'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TF-Login'!

!TLMultiFileDatabaseTest methodsFor: 'setup-and-teardown' stamp: 'TonyFleig 1/2/2011 21:10'!
setUp
	db := TLMultiFileDatabase on: 'MultiFileDatabaseTestDb'.! !

!TLMultiFileDatabaseTest methodsFor: 'setup-and-teardown' stamp: 'TonyFleig 12/31/2010 15:15'!
tearDown
	db deleteDatabase! !

!TLMultiFileDatabaseTest methodsFor: 'tests' stamp: 'TonyFleig 12/31/2010 15:20'!
testSaveAndRestore 

	| obj1 obj2 |
	
	obj1 := '123'.
	obj2 := '456'.
	
	db saveObject: obj1 withName: 'obj1'.
	db saveObject: obj2 withName: 'obj2'.
	
	obj1 := db restoreObjectNamed: 'obj2'.
	self assert: obj1 = '456'.
	
	obj1 := db restoreObjectNamed: 'obj1'.
	self assert: obj1 = '123'.

	obj1 := OrderedCollection with: 'aaa' with: 'bbb'.
	db saveObject: obj1 withName: 'obj1'.
	
	self assert: ((db restoreObjectNamed: 'obj1') at: 2) = 'bbb'.! !

!TLMultiFileDatabaseTest methodsFor: 'tests' stamp: 'TonyFleig 12/31/2010 15:35'!
testVersions
	| obj1 obj2 |
	obj1 := 0.
	db saveObject: obj2 withName: '2'.
	obj2 := 1000.
	db maxEntryCount: 3.
	
	1 to: 42 do: [ :n |
		obj1 := n.
		db saveObject: obj1 withName: '1'.
		obj2 := 1000 + n..
		db saveObject: obj2 withName: '2'].
	
	self assert: (db lastSavedFileNamed: '1') = '1.42'.
	self assert: obj1 = 42.

	self assert: (db lastSavedFileNamed: '2') = '2.43'.
	self assert: obj2 = 1042.

	db deleteFilesNamed: '1'.
	self assert: (db lastSavedFileNamed: '1') isNil.
	self assert: (db restoreObjectNamed: '1') isNil
		 ! !

TestCase subclass: #TLTest
	instanceVariableNames: 'existingPort wasRunning client port'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TF-Login'!

!TLTest class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/12/2011 10:38'!
automatedTestingBlogArticle

^ (GZipReadStream on: (Base64MimeConverter mimeDecodeToChars:
'H4sIAAAAAAAAAOVaW2/byBV+zoP/w8ApKjuw5bb75oWLZnPZFZrdNWKnKVq4ixE5kgamOCqH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'
readStream) contents) contents! !

!TLTest class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/12/2011 09:51'!
showArticle
	| ws |
	(FileStream forceNewFileNamed: 'AutomatedTestingBlogArticle.txt')
		nextPutAll: TLTest automatedTestingBlogArticle;
		close.
	ws := (Workspace openFile: 'AutomatedTestingBlogArticle.txt')
		label: 'AutomatedTestingBlogArticle.txt'.
	ws topView
		position: 100@100;
		extent: 800@400! !

!TLTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/10/2011 08:45'!
actionUrlFor: aForm
	^ self baseUrl, (aForm attributeAt: 'action'). ! !

!TLTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/10/2011 08:32'!
baseUrl
	^ 'http://localhost:', self port asString! !

!TLTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/11/2011 16:42'!
clickOn: anId in: content
	^ self clickOn: anId in: content with: Dictionary new.! !

!TLTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/11/2011 16:43'!
clickOn: anId in: content with: valuesById

	| form names response url args |

	form := self findForm: content.
	url := self actionUrlFor: form.
	names := self controlsById: form.
	args := Dictionary new.
	
	valuesById keysAndValuesDo: [ :k :v |
		args at: (names at: k) put: v ].
	args at: (names at: anId) put: ''.
	response := (client post: url data: args).
	response code = 302 ifTrue: [
		url := self baseUrl, (response headers at: 'Location').
		response := client get: url ].
	^ response contents! !

!TLTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/10/2011 08:49'!
controlsById: aForm
	| tags dict |
	dict := Dictionary new.
	tags := #( 'input' 'button').
	
	tags do: [ :eachTag |
		(aForm findAllTags: eachTag) do: [ :each |
			| id |
			id := each attributeAt: 'id'.
			id isNil ifFalse: [ dict at: id put: (each attributeAt: 'name')  ]]].
	^ dict! !

!TLTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/10/2011 08:42'!
findForm: aString
	^ (Soup fromString: aString) findTag: 'form'

! !

!TLTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/13/2011 09:44'!
findFormIn: content withClass: className
	^ self findTag: 'form' in: content withClass: className 
! !

!TLTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/13/2011 09:44'!
findTag: tagName in: content withClass: aClassName
	| tag |
	^ (tag := ((Soup fromString: content) findTagByClass: aClassName)) name = tagName
		ifTrue: [ tag ]
		ifFalse: [ nil ]

! !

!TLTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/13/2011 09:46'!
findTag: tagName in: content withId: id
	^ ((Soup fromString: content) findAllTags: tagName) detect: [ :each |
		 (each attributeAt: 'id') = id ] ifNone: [ nil ]! !

!TLTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/11/2011 16:43'!
getStartPage
	^ (client get: self baseUrl, '/', TLTester appName) contents.
! !

!TLTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/10/2011 14:44'!
port
	^ port! !

!TLTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/10/2011 14:43'!
port: aPortNUmber
	port := aPortNUmber ! !

!TLTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/11/2011 16:43'!
registerTestUser1
	| content loginform controls url |

	content := self getStartPage.
	content := self clickOn: 'registerbtn' in: content.	
	content := self
		clickOn: 'registerbtn'
		in: content
		with: ((Dictionary new)
			at: 'registeruser' put: 'TestUser1';
			at: 'registerpswd' put: 'testpass';
			at: 'registerconfirmpswd' put: 'testpass';
			at: 'registeremail' put: 'myemail';
			yourself).
	self assert: ((Soup fromString: content) findTagByClass: 'loginconfsuccess') isNil not.
! !

!TLTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/11/2011 16:44'!
registerTestUser2
	| content loginform controls url |

	content := self getStartPage.
	content := self clickOn: 'registerbtn' in: content.
	content := self
		clickOn: 'registerbtn'
		in: content
		with: ((Dictionary new)
			at: 'registeruser' put: 'TestUser2';
			at: 'registerpswd' put: 'testpass2';
			at: 'registerconfirmpswd' put: 'testpass2';
			at: 'registeremail' put: 'myemail';
			yourself).
	self assert: ((Soup fromString: content) findTagByClass: 'loginconfsuccess') isNil not.
! !

!TLTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/13/2011 09:17'!
setUp

	self port: WAKomEncoded default port.		

	self assert: (WAKomEncoded default isRunning ) description: 'This test needs a Seaside server.'.

	self assert: ((Smalltalk at: #Soup ifAbsent: [nil]) isNil not) description: 'This test requires Soup: http://www.squeaksource.com/Soup'.
	self assert: ((Smalltalk at: #ZnClient ifAbsent: [nil]) isNil not) description: 'This test requires Zinc http://www.squeaksource.com/ZincHTTPComponents'.
	
	"Gofer it
  		squeaksource: 'ZincHTTPComponents';
  		package: 'Zinc-HTTP';
  		package: 'Zinc-Tests';
  		load"
	
	TLTester testing: true.
	TLTester initialize.
	TLTester sendRegistrationConfirmationEmail: false.
	TLTester confirmationTimeoutMinutes: 10.
	TLTester setPasswordValidator: false.
	TLTester allowEmptyPasswords: false.
	(TLFileStorageAdaptor name: TLTester appName) deleteDatabase. 
	TLAuthenticationManager initialize.
	client := (ZnHttpClient new).
	client settings followRedirect: false.
	client settings timeout: 3.

	 ! !

!TLTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/11/2011 16:42'!
tearDown
	TLTester uninitialize.
	(TLFileStorageAdaptor name: TLTester appName) deleteDatabase. 
	TLAuthenticationManager initialize.
	"client close."
		
	 ! !

!TLTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/12/2011 10:25'!
testForgotPassword

	| content loginform controls url tag |

	Transcript cr; show: 'testForgotPassword'.

	TLTester passwordResetEmailSender: [ :resetUrl :email : timeout |
		self assert: email = 'myemail'.
		url := resetUrl..
		self assert: timeout = 5.
		true ].
	TLTester confirmationTimeoutMinutes: 5.
	self registerTestUser1.
	content := self getStartPage.
	content := self
		clickOn: 'forgotpasswordbtn'
		in: content.
	content := self
		clickOn: 'forgotpasswordokbtn'
		in: content
		with: ((Dictionary new)
			at: 'forgotpasswordusername' put: 'TestUser1';
			yourself).
	self assert: (self findFormIn: content withClass: 'passwordemailsent' ) notNil.
	content := self
		clickOn: 'passwordemailsentokbtn'
		in: content.
	content := (ZnClient get: url) contents.
	self assert: (self findFormIn: content withClass: 'passwordresetform') notNil.
	content := self
		clickOn: 'resetbtn'
		in: content
		with: ((Dictionary new)
			at: 'resetpswduser' put: 'TestUser1';
			at: 'resetpswd' put: 'password2';
			at: 'resetpswdconfirm' put: 'password2';
			yourself).
	self assert: (self findFormIn: content  withClass: 'pswdresetsuccessform') notNil.
	content := self
		clickOn: 'passwordresetsuccessokbtn'
		in: content.
	self assert: (self findFormIn: content  withClass: 'loginform') notNil.
	content := self
		clickOn: 'loginbtn'
		in: content
		with: ((Dictionary new)
			at: 'loginuser' put: 'TestUser1';
			at: 'loginpswd' put: 'password2';
			yourself).
	self assert: (self findFormIn: content withClass: 'loggedinform') notNil.
	
! !

!TLTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/13/2011 09:58'!
testForgotPasswordEmptyAllowed

	| content loginform controls url tag |

	Transcript cr; show: 'testForgotPasswordEmptyAllowed'.

	TLTester passwordResetEmailSender: [ :resetUrl :email : timeout |
		self assert: email = 'myemail'.
		url := resetUrl..
		self assert: timeout = 5.
		true ].
	TLTester allowEmptyPasswords: true.
	TLTester confirmationTimeoutMinutes: 5.
	self registerTestUser1.
	content := self getStartPage.
	content := self
		clickOn: 'forgotpasswordbtn'
		in: content.
	content := self
		clickOn: 'forgotpasswordokbtn'
		in: content
		with: ((Dictionary new)
			at: 'forgotpasswordusername' put: 'TestUser1';
			yourself).
	self assert: (self findFormIn: content  withClass: 'passwordemailsent' ) notNil.
	content := self
		clickOn: 'passwordemailsentokbtn'
		in: content.
	content := (ZnClient get: url) contents.
	self assert: (self findFormIn: content withClass: 'passwordresetform') notNil.
	content := self
		clickOn: 'resetbtn'
		in: content
		with: ((Dictionary new)
			at: 'resetpswduser' put: 'TestUser1';
			at: 'resetpswd' put: '';
			at: 'resetpswdconfirm' put: '';
			yourself).
	self assert: (self findFormIn: content  withClass: 'pswdresetsuccessform') notNil.
! !

!TLTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/13/2011 09:58'!
testForgotPasswordEmptyNotAllowed

	| content loginform controls url tag |

	Transcript cr; show: 'testForgotPasswordEmptyNotAllowed'.

	TLTester passwordResetEmailSender: [ :resetUrl :email : timeout |
		self assert: email = 'myemail'.
		url := resetUrl..
		self assert: timeout = 5.
		true ].
	TLTester confirmationTimeoutMinutes: 5.
	self registerTestUser1.
	content := self getStartPage.
	content := self
		clickOn: 'forgotpasswordbtn'
		in: content.
	content := self
		clickOn: 'forgotpasswordokbtn'
		in: content
		with: ((Dictionary new)
			at: 'forgotpasswordusername' put: 'TestUser1';
			yourself).
	self assert: (self findFormIn: content  withClass: 'passwordemailsent' ) notNil.
	content := self
		clickOn: 'passwordemailsentokbtn'
		in: content.
	content := (ZnClient get: url) contents.
	self assert: (self findFormIn: content withClass: 'passwordresetform') notNil.
	content := self
		clickOn: 'resetbtn'
		in: content
		with: ((Dictionary new)
			at: 'resetpswduser' put: 'TestUser1';
			at: 'resetpswd' put: '';
			at: 'resetpswdconfirm' put: '';
			yourself).
	self assert: (self findTag: 'div' in: content withId:  'resetpasswordempty' ) notNil.
! !

!TLTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/13/2011 09:58'!
testForgotPasswordInvalid

	| content loginform controls url tag |

	Transcript cr; show: 'testForgotPasswordInvalid'.

	TLTester passwordResetEmailSender: [ :resetUrl :email : timeout |
		self assert: email = 'myemail'.
		url := resetUrl..
		self assert: timeout = 5.
		true ].
	TLTester confirmationTimeoutMinutes: 5.
	TLTester setPasswordValidator: true.
	self registerTestUser1.
	content := self getStartPage.
	content := self
		clickOn: 'forgotpasswordbtn'
		in: content.
	content := self
		clickOn: 'forgotpasswordokbtn'
		in: content
		with: ((Dictionary new)
			at: 'forgotpasswordusername' put: 'TestUser1';
			yourself).
	self assert: (self findFormIn: content  withClass: 'passwordemailsent' ) notNil.
	content := self
		clickOn: 'passwordemailsentokbtn'
		in: content.
	content := (ZnClient get: url) contents.
	self assert: (self findFormIn: content withClass: 'passwordresetform') notNil.
	content := self
		clickOn: 'resetbtn'
		in: content
		with: ((Dictionary new)
			at: 'resetpswduser' put: 'TestUser1';
			at: 'resetpswd' put: 'pswd';
			at: 'resetpswdconfirm' put: 'pswd';
			yourself).
	self assert: (self findTag: 'div' in: content withId:  'resetpasswordinvalid' ) notNil.
! !

!TLTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/13/2011 09:58'!
testForgotPasswordMismatch

	| content loginform controls url tag |

	Transcript cr; show: 'testForgotPasswordMismatch'.

	TLTester passwordResetEmailSender: [ :resetUrl :email : timeout |
		self assert: email = 'myemail'.
		url := resetUrl..
		self assert: timeout = 5.
		true ].
	TLTester confirmationTimeoutMinutes: 5.
	self registerTestUser1.
	content := self getStartPage.
	content := self
		clickOn: 'forgotpasswordbtn'
		in: content.
	content := self
		clickOn: 'forgotpasswordokbtn'
		in: content
		with: ((Dictionary new)
			at: 'forgotpasswordusername' put: 'TestUser1';
			yourself).
	self assert: (self findFormIn: content  withClass: 'passwordemailsent' ) notNil.
	content := self
		clickOn: 'passwordemailsentokbtn'
		in: content.
	content := (ZnClient get: url) contents.
	self assert: (self findFormIn: content withClass: 'passwordresetform') notNil.
	content := self
		clickOn: 'resetbtn'
		in: content
		with: ((Dictionary new)
			at: 'resetpswduser' put: 'TestUser1';
			at: 'resetpswd' put: 'password2';
			at: 'resetpswdconfirm' put: 'password3';
			yourself).
	self assert: (self findTag: 'div' in: content withId:  'resetpasswordmismatch' ) notNil.
! !

!TLTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/13/2011 09:58'!
testForgotPasswordUsernameMismatch

	| content loginform controls url tag |

	Transcript cr; show: 'testForgotPasswordUsernameMismatch'.

	TLTester passwordResetEmailSender: [ :resetUrl :email : timeout |
		self assert: email = 'myemail'.
		url := resetUrl..
		self assert: timeout = 5.
		true ].
	TLTester confirmationTimeoutMinutes: 5.
	self registerTestUser1.
	content := self getStartPage.
	content := self
		clickOn: 'forgotpasswordbtn'
		in: content.
	content := self
		clickOn: 'forgotpasswordokbtn'
		in: content
		with: ((Dictionary new)
			at: 'forgotpasswordusername' put: 'TestUser1';
			yourself).
	self assert: (self findFormIn: content  withClass: 'passwordemailsent' ) notNil.
	content := self
		clickOn: 'passwordemailsentokbtn'
		in: content.
	content := (ZnClient get: url) contents.
	self assert: (self findFormIn: content withClass: 'passwordresetform') notNil.
	content := self
		clickOn: 'resetbtn'
		in: content
		with: ((Dictionary new)
			at: 'resetpswduser' put: 'TestUser2';
			at: 'resetpswd' put: 'password2';
			at: 'resetpswdconfirm' put: 'password2';
			yourself).
	self assert: (self findTag: 'div' in: content withId:  'resetpasswordusernamemismatch' ) notNil.
! !

!TLTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/11/2011 16:44'!
testForgotUsername

	| content loginform controls url tag |

	Transcript cr; show: 'testForgotUsername'.

	TLTester usernameReminderEmailSender: [ :usernames :email |
		self assert: email = 'myemail'.
		self assert: (usernames includes: 'TestUser1').
		self assert: (usernames includes: 'TestUser2').
		true ].
	self registerTestUser1.
	self registerTestUser2.
	content := self getStartPage.
	content := self
		clickOn: 'forgotusernamebtn'
		in: content.
	content := self
		clickOn: 'forgotusernameokbtn'
		in: content
		with: ((Dictionary new)
			at: 'forgotusernameemail' put: 'myemail';
			yourself).
	self assert: ((Soup fromString: content) findTagByClass: 'usernameemailsent' ) isNil not.
	content := self
		clickOn: 'usernameemailsentokbtn'
		in: content.
		
! !

!TLTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/11/2011 16:44'!
testForgotUsernameEmailFail

	| content loginform controls url tag |

	Transcript cr; show: 'testForgotUsernameEmailFail'.

	TLTester usernameReminderEmailSender: [ :usernames :email |
		self assert: email = 'myemail'.
		self assert: (usernames includes: 'TestUser1').
		false ].
	self registerTestUser1.
	content := self getStartPage.
	content := self
		clickOn: 'forgotusernamebtn'
		in: content.
	content := self
		clickOn: 'forgotusernameokbtn'
		in: content
		with: ((Dictionary new)
			at: 'forgotusernameemail' put: 'myemail';
			yourself).
	content := self
		clickOn: 'usernameemailsentokbtn'
		in: content.
		
! !

!TLTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/13/2011 09:43'!
testLoginFailHandler

	| content loginform controls url tag |

	Transcript cr; show: 'testLoginFailHandler'.

	TLTester setLoginFilter: true.
	TLTester setLoginFailHandler: true.
	self registerTestUser1.

	content := self getStartPage.
	3 timesRepeat: [
		content := self
			clickOn: 'loginbtn'
			in: content
				with: ((Dictionary new)
				at: 'loginuser' put: 'TestUser1';
				at: 'loginpswd' put: 'badpass';
				yourself)]..
	content := self
		clickOn: 'loginbtn'
		in: content
			with: ((Dictionary new)
			at: 'loginuser' put: 'TestUser1';
			at: 'loginpswd' put: 'testpass';
			yourself).
	self assert: (self findTag: 'div' in: content withClass: 'autherror') notNil
! !

!TLTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/12/2011 21:19'!
testLoginFilter

	| content loginform controls url tag |

	Transcript cr; show: 'testLoginFilter'.

	TLTester setLoginFilter: true.
	self registerTestUser1.

	content := self getStartPage.
	5 timesRepeat: [
		content := self
			clickOn: 'loginbtn'
			in: content
				with: ((Dictionary new)
				at: 'loginuser' put: 'TestUser1';
				at: 'loginpswd' put: 'testpass';
				yourself).
		content := self
			clickOn: 'logoutbtn'
			in: content].
.
	content := self
		clickOn: 'loginbtn'
		in: content
			with: ((Dictionary new)
			at: 'loginuser' put: 'TestUser1';
			at: 'loginpswd' put: 'testpass';
			yourself).
	self assert: ((Soup fromString: content) findString: 'Too many logins') notNil
! !

!TLTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/11/2011 16:44'!
testLoginLogout

	| content loginform controls url tag |

	Transcript cr; show: 'testLoginLogout'.

	self registerTestUser1.
	content := self getStartPage.
	content := self
		clickOn: 'loginbtn'
		in: content
		with: ((Dictionary new)
			at: 'loginuser' put: 'TestUser1';
			at: 'loginpswd' put: 'testpass';
			yourself).
	tag := (Soup fromString: content) findTag: 'button'.
	self assert: tag isNil not.
	self assert: (tag attributeAt: 'id') = 'logoutbtn'.	
	content := self
		clickOn: 'logoutbtn'
		in: content.
	self deny: ((Soup fromString: content) findTagByClass: 'loginform') isNil.	
! !

!TLTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/11/2011 16:45'!
testRegisterEmptyPassword

	| content loginform controls url tag |
	
	Transcript cr; show: 'testRegisterEmptyPassword'.
	
	content := self getStartPage.
	content := self clickOn: 'registerbtn' in: content.
	content := self
		clickOn: 'registerbtn'
		in: content
		with: ((Dictionary new)
			at: 'registeruser' put: 'TestUser1';
			at: 'registerpswd' put: '';
			at: 'registerconfirmpswd' put: '';
			yourself).
	tag := (Soup fromString: content) findTagByClass: 'registererror'.
	self deny: tag isNil.
	self assert: (tag attributeAt: 'id') = 'registerpasswordempty'.

! !

!TLTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/11/2011 16:45'!
testRegisterEmptyPasswordAllowed

	| content loginform controls url tag |

	Transcript cr; show: 'testRegisterEmptyPasswordAllowed'.

	TLTester allowEmptyPasswords: true.
	content := self getStartPage.
	content := self clickOn: 'registerbtn' in: content.
	content := self
		clickOn: 'registerbtn'
		in: content
		with: ((Dictionary new)
			at: 'registeruser' put: 'TestUser1';
			at: 'registerpswd' put: '';
			at: 'registerconfirmpswd' put: '';
			yourself).
	self assert: ((Soup fromString: content) findTagByClass: 'loginconfsuccess') isNil not.

! !

!TLTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/11/2011 16:45'!
testRegisterInvalidPassword

	| content loginform controls url tag |

	Transcript cr; show: 'testRegisterInvalidPassword'.

	TLTester setPasswordValidator: true.
	content := self getStartPage.
	content := self clickOn: 'registerbtn' in: content.
	content := self
		clickOn: 'registerbtn'
		in: content
		with: ((Dictionary new)
			at: 'registeruser' put: 'TestUser1';
			at: 'registerpswd' put: 'pass';
			at: 'registerconfirmpswd' put: 'pass';
			yourself).
	tag := (Soup fromString: content) findTagByClass: 'registererror'.
	self deny: tag isNil.
	self assert: (tag attributeAt: 'id') = 'registerpasswordinvalid'.
	self deny: (tag findString: 'password too short') isNil.

! !

!TLTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/13/2011 09:57'!
testRegisterMany

	| content loginform controls url |

	content := self getStartPage.
	1 to: 10 do: [ :n |
		content := self clickOn: 'registerbtn' in: content.	
		content := self
			clickOn: 'registerbtn'
			in: content
			with: ((Dictionary new)
				at: 'registeruser' put: 'TestUser', n asString;
				at: 'registerpswd' put: 'testpass', n asString;
				at: 'registerconfirmpswd' put: 'testpass', n asString;
				at: 'registeremail' put: 'myemail', n asString;
				yourself).
		self assert: ((Soup fromString: content) findTagByClass: 'loginconfsuccess') isNil not ].
! !

!TLTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/11/2011 16:45'!
testRegisterPasswordMismatch

	| content loginform controls url tag |

	Transcript cr; show: 'testRegisterPasswordMismatch'.

	content := self getStartPage.
	content := self clickOn: 'registerbtn' in: content.
	content := self
		clickOn: 'registerbtn'
		in: content
		with: ((Dictionary new)
			at: 'registeruser' put: 'TestUser1';
			at: 'registerpswd' put: 'testpass';
			at: 'registerconfirmpswd' put: 'testpassxxx';
			yourself).
	tag := (Soup fromString: content) findTagByClass: 'registererror'.
	self deny: tag isNil.
	self assert: (tag attributeAt: 'id') = 'registerpasswordmismatch'.
! !

!TLTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/11/2011 16:46'!
testRegisterSuccess

	Transcript cr; show: 'testRegisterSuccess'.

	self registerTestUser1! !

!TLTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/11/2011 16:46'!
testRegisterSuccessWithEmailConfirmation

	| content loginform controls url myemail confirmUrl |
	
	Transcript cr; show: 'testRegisterSuccessWithEmailConfirmation'.

	myemail := 'meatmyemailcom'.
	TLTester registrationConfirmationEmailSender: [ :confUrl :email :timeout |
		self assert: email = myemail.
		self assert: timeout = 2.
		confirmUrl := confUrl.
		true ].
	TLTester sendRegistrationConfirmationEmail: true.
	TLTester confirmationTimeoutMinutes: 2.
	content := self getStartPage.
	content := self clickOn: 'registerbtn' in: content.	
	content := self
		clickOn: 'registerbtn'
		in: content
		with: ((Dictionary new)
			at: 'registeruser' put: 'TestUser1';
			at: 'registerpswd' put: 'testpass';
			at: 'registerconfirmpswd' put: 'testpass';
			at: 'registeremail' put: myemail;
			yourself).
	self assert: ((Soup fromString: content) findTagByClass: 'regsubmitted') isNil not.
	content := (ZnClient get: confirmUrl) contents.
	self assert: ((Soup fromString: content) findTagByClass: 'loginconfsuccess') isNil not.
! !

!TLTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/11/2011 16:46'!
testRegisterSuccessWithEmailConfirmationFail

	| content loginform controls url myemail |
	
	Transcript cr; show: 'testRegisterSuccessWithEmailConfirmationFail'.

	myemail := 'meatmyemailcom'.
	TLTester registrationConfirmationEmailSender: [ :confirmUrl :email :timeout |
		self assert: email = myemail.
		false ].
	TLTester sendRegistrationConfirmationEmail: true.
	content := self getStartPage.
	content := self clickOn: 'registerbtn' in: content.	
	content := self
		clickOn: 'registerbtn'
		in: content
		with: ((Dictionary new)
			at: 'registeruser' put: 'TestUser1';
			at: 'registerpswd' put: 'testpass';
			at: 'registerconfirmpswd' put: 'testpass';
			at: 'registeremail' put: myemail;
			yourself).
	self assert: ((Soup fromString: content) findTagByClass: 'regsubmitfailed') isNil not.! !

!TLTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/11/2011 16:46'!
testRegisterSuccessWithEmailConfirmationTimeout

	| content loginform controls url myemail confirmUrl |
	
	Transcript cr; show: 'testRegisterSuccessWithEmailConfirmationTimeout'.

	myemail := 'meatmyemailcom'.
	TLTester registrationConfirmationEmailSender: [ :confUrl :email :timeout |
		self assert: email = myemail.
		self assert: timeout = 0.
		confirmUrl := confUrl.
		true ].
	TLTester sendRegistrationConfirmationEmail: true.
	TLTester confirmationTimeoutMinutes: 0.
	content := self getStartPage.
	content := self clickOn: 'registerbtn' in: content.	
	content := self
		clickOn: 'registerbtn'
		in: content
		with: ((Dictionary new)
			at: 'registeruser' put: 'TestUser1';
			at: 'registerpswd' put: 'testpass';
			at: 'registerconfirmpswd' put: 'testpass';
			at: 'registeremail' put: myemail;
			yourself).
	self assert: ((Soup fromString: content) findTagByClass: 'regsubmitted') isNil not.
	content := (ZnClient get: confirmUrl) contents.
	self assert: ((Soup fromString: content) findTagByClass: 'loginconffailed') isNil not.		
! !

!TLTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/11/2011 16:46'!
testRegisterUsernameExists

	| content loginform controls url tag |

	Transcript cr; show: 'testRegisterUsernameExists'.

	content := self getStartPage.
	content := self clickOn: 'registerbtn' in: content.
	content := self
		clickOn: 'registerbtn'
		in: content
		with: ((Dictionary new)
			at: 'registeruser' put: 'TestUser1';
			at: 'registerpswd' put: 'testpass';
			at: 'registerconfirmpswd' put: 'testpass';
			yourself).
	self assert: ((Soup fromString: content) findTagByClass: 'loginconfsuccess') isNil not.
	content := self clickOn: 'registerbtn' in: content.
	content := self
		clickOn: 'registerbtn'
		in: content
		with: ((Dictionary new)
			at: 'registeruser' put: 'TestUser1';
			at: 'registerpswd' put: 'testpass2';
			at: 'registerconfirmpswd' put: 'testpass2';
			yourself).
	tag := (Soup fromString: content) findTagByClass: 'registererror'.
	self deny: tag isNil.
	self assert: (tag attributeAt: 'id') = 'registerusernameexists'.

! !

TestCase subclass: #TLUserTest
	instanceVariableNames: 'user loginTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TF-Login'!

TLUserTest subclass: #TLRegisteredUserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TF-Login'!

TLRegisteredUserTest subclass: #TLPendingUserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TF-Login'!

!TLPendingUserTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/2/2011 21:13'!
setUp
	user := TLPendingUser
		username: 'TestUser'
		password: 'password'
		email: 'user@emailaddress'
		regId: 'xyzzy'
		confirmationDeadline: (Time deadlineSecs: 60)! !

!TLPendingUserTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/25/2010 08:59'!
testConfirmationDeadline
	user confirmationDeadline: 12345.
	self assert: (user confirmationDeadline = 12345)! !

!TLPendingUserTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/25/2010 08:53'!
testEmail
	super testEmail! !

!TLPendingUserTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/25/2010 08:52'!
testIsValid
	self assert: (user isValid).
	user confirmationDeadline: (Time deadlineSecs: -1).
	self deny: (user isValid)! !

!TLPendingUserTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/28/2010 18:25'!
testRegId

	self assert: (user regId = 'xyzzy').
	user regId: 12345.
	self assert: (user regId = 12345)! !

!TLPendingUserTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/25/2010 09:06'!
testUnimplemented
	self should: [user lastLogin] raise: Error.
	self should: [user lastLogin: DateAndTime now] raise: Error.
	self should: [user lastLoginFrom] raise: Error.
	self should: [user lastLoginFrom: '127.0.0.1'] raise: Error.
	! !

!TLRegisteredUserTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/2/2011 21:13'!
setUp
	user := TLRegisteredUser
		username: 'TestUser'
		password: 'password'
		email: 'user@emailaddress'.
! !

!TLRegisteredUserTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/25/2010 08:33'!
testEmail
	super testEmail! !

!TLRegisteredUserTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/25/2010 08:21'!
testIncrementLoginCount
	user loginCount: 1.
	user incrementLoginCount.
	self assert: (user loginCount = 2)! !

!TLRegisteredUserTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/9/2011 12:12'!
testLastLogin
	| loginDT |
	self assert: (user lastLogin = DateAndTime epoch).
	user lastLogin: (loginDT := DateAndTime now).
	self assert: (user lastLogin = loginDT).
	! !

!TLRegisteredUserTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/9/2011 12:12'!
testLastLoginFrom
	self assert: (user lastLogin = DateAndTime epoch).
	user lastLoginFrom: '192.168.1.2'.
	self assert: (user lastLoginFrom = '192.168.1.2' ).
	! !

!TLRegisteredUserTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/25/2010 08:34'!
testLoginCount
	super testLoginCount ! !

!TLRegisteredUserTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/25/2010 08:34'!
testUsername
	super testUsername ! !

!TLUserTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/2/2011 21:09'!
setUp
	user := TLUser
		username: 'TestUser'
		email: 'user@emailaddress'
		lastLogin: (loginTime := DateAndTime now)
		lastLoginFrom: '127.0.0.1'
		loginCount: 0! !

!TLUserTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/25/2010 08:24'!
testConfirmationDeadline
	self should: [ user confirmationDeadline ] raise: MessageNotUnderstood.
	self should: [ user confirmationDeadline: 123456 ] raise: MessageNotUnderstood.
	
! !

!TLUserTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/25/2010 08:24'!
testEmail
	self assert: (user email = 'user@emailaddress').
	user email: 'user@newaddress'.
	self assert: (user email = 'user@newaddress').
	
	! !

!TLUserTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/25/2010 08:25'!
testLastLogin
	self assert: (user lastLogin = loginTime).
	user lastLogin: (loginTime := DateAndTime now).
	self assert: (user lastLogin = loginTime).
	! !

!TLUserTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/25/2010 08:26'!
testLastLoginFrom
	self assert: (user lastLoginFrom = '127.0.0.1' ).
	user lastLoginFrom: '192.168.1.2'.
	self assert: (user lastLoginFrom = '192.168.1.2' ).
	! !

!TLUserTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/25/2010 08:26'!
testLoginCount
	self assert: (user loginCount = 0).
	user loginCount: 42.
	self assert: (user loginCount = 42).
	! !

!TLUserTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/25/2010 08:27'!
testPassword
	self should: [ user password ] raise: MessageNotUnderstood.
	self should: [ user password: 'xxx' ] raise: MessageNotUnderstood.
	! !

!TLUserTest methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/25/2010 08:27'!
testUsername
	self assert: (user username = 'TestUser').
	user username: 'NewUser'.
	self assert: (user username = 'NewUser').
	! !

WASession subclass: #TLSession
	instanceVariableNames: 'user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TF-Login'!

!TLSession methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/24/2010 17:19'!
user
	^user! !

!TLSession methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/24/2010 17:19'!
user: aUser
	user := aUser! !

WASystemConfiguration subclass: #TLConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TF-Login'!

!TLConfiguration class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/8/2011 09:08'!
initialize
	"If changes are made to the TLConfiguration>>describeOn: method, excecute this method to remove the singleton instance. This
	will force the configuration object to be recreated with the changes"
	
	"TLConfiguration initialize"
	instance := nil! !

!TLConfiguration methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/8/2011 09:13'!
describeOn: config
	<lint: 'Overrides super method without calling it' rationale: 'This is a should override' author: 'TF'>

	(config boolean: #sendRegistrationConfirmationEmail)
		group: #login;
		default: false;
		comment: 'Confirm registrations via email.'.
	(config integer: #confirmationTimeoutMinutes)
		group: #login;
		default: 10;
		comment: 'Minutes to wait after sending registration and password reset emails'.
	(config boolean: #useRecaptchaInRegistrationForm)
		group: #login;
		default: false;
		comment: 'Protect registration form against spam with reCAPTCHA'.
	(config boolean: #confirmEmailChangeViaEmail)
		group: #login;
		default: false;
		comment: 'Confirm email address changes by sending email to the new address'.
	(config boolean: #confirmAccountChangesViaEmail)
		group: #login;
		default: false;
		comment: 'Confirm all account changes by sending email to the (possibly new) address'.

	(config boolean: #allowEmptyPasswords)
		group: #login;
		default: false;
		comment: 'Allow empty passwords'.

	(config boolean: #allowUsernameChange)
		group: #login;
		default: false;
		comment: 'Allow users to change their username'.

	(config boolean: #allowRememberUsername)
		group: #login;
		default: false;
		comment: 'Allow users to remember their username in a cookie'.

	(config boolean: #allowAutomaticLogin)
		group: #login;
		default: false;
		comment: 'Allow users to remember their username and password in a cookie'.

	(config integer: #UsernamePasswordRememberDays)
		group: #login;
		default: 7;
		comment: 'Expiration period for username and password cookies'.

! !

WASystemConfiguration subclass: #TLTestAppConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TF-Login'!

!TLTestAppConfiguration class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/8/2011 09:09'!
initialize
	"If changes are made to the TLTestAppConfiguration>>describeOn: method, excecute this method to remove the singleton instance. This
	will force the configuration object to be recreated with the changes"
	
	"TLTestAppConfiguration initialize"
	instance := nil! !

!TLTestAppConfiguration methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/8/2011 10:52'!
describeOn: config
	<lint: 'Overrides super method without calling it' rationale: 'This is a should override' author: 'TF'>

	(config integer: #minimumPasswordLength)
		group: #tltestapp;
		default: 6;
		comment: 'Required minimum password length'.
	(config integer: #maximumFailedLoginAttempts)
		group: #tltestapp;
		default: 3;
		comment: 'Maximum failed login attempts allowed before account is disabled.'.

! !

Object subclass: #TLApplicationPropertyItem
	instanceVariableNames: 'includeInAccountDetails'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TF-Login'!

!TLApplicationPropertyItem commentStamp: '<historical>' prior: 0!
Not sure whether this is really needed...!

!TLApplicationPropertyItem methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/27/2010 18:51'!
includeInAccountDetails
	^ includeInAccountDetails ifNil: [ false ]! !

!TLApplicationPropertyItem methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/27/2010 18:52'!
includeInAccountDetails: aBoolean
	includeInAccountDetails := aBoolean ! !

!TLApplicationPropertyItem methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/9/2011 12:45'!
renderOn: html
	"Override if includeInAccountDetails is true."
	^ self! !

TLApplicationPropertyItem subclass: #TLTestAppLoginHistory
	instanceVariableNames: 'list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TF-Login'!

!TLTestAppLoginHistory methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/27/2010 18:55'!
includeInAccountDetails
	^ includeInAccountDetails ifNil: [ true ]! !

!TLTestAppLoginHistory methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/27/2010 19:10'!
list
	^ list ifNil: [ list := OrderedCollection new ]! !

!TLTestAppLoginHistory methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/5/2011 11:27'!
renderOn: html
	html div
		style: 'width: 400px; height: 100px; overflow: auto; border: 1px solid black';
		with: [
			self list do: [ :each |
				html text: each; break ]].! !

Object subclass: #TLAuthenticationManager
	instanceVariableNames: 'storageAdaptor appName confirmationTimeout loginComponent'
	classVariableNames: 'Lock PendingActions'
	poolDictionaries: ''
	category: 'TF-Login'!

!TLAuthenticationManager class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 08:10'!
generateRegId
	^ UUID new primMakeUUID asString36.! !

!TLAuthenticationManager class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 11:31'!
initialize 
	Lock := Semaphore forMutualExclusion.
	PendingActions := Dictionary new.! !

!TLAuthenticationManager class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/10/2011 12:00'!
loginComponent:  aLoginComponent
	^ self basicNew
		initialize;
		appName: aLoginComponent appName;
		loginComponent: aLoginComponent;
		yourself! !

!TLAuthenticationManager class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 06:20'!
name: anAppName
	^ self basicNew
		initialize;
		appName: anAppName;
		yourself! !

!TLAuthenticationManager class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 06:20'!
new
	self shouldNotImplement ! !

!TLAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/2/2011 21:14'!
addPendingAccountChange: user regId: regId
	| pendingAccountChange |
	
	pendingAccountChange  := TLPendingAcountChange  
				fromUser: user
				regId: regId
				confirmationDeadline: (Time deadlineSecs: self confirmationTimeout).
	
	Lock critical: [
		self pendingActions 
			at: regId
			put: pendingAccountChange].
		
	^pendingAccountChange ! !

!TLAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/2/2011 21:14'!
addPendingPasswordResetUser: user regId: regId
	| pendingPasswordReset |
	
	pendingPasswordReset := TLPendingPasswordReset 
				username: user username
				regId: regId
				confirmationDeadline: (Time deadlineSecs: self confirmationTimeout).
	
	Lock critical: [self pendingActions 
		at: regId
		put: pendingPasswordReset].
		
	^pendingPasswordReset! !

!TLAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/2/2011 21:13'!
addPendingRegistrationUser: user password: pswd email: em regId: regId
	
	| pendingUser |
	pendingUser := TLPendingUser
				username: user
				password: pswd
				email: em
				regId: regId
				confirmationDeadline: (Time deadlineSecs: self confirmationTimeout).
	
	Lock critical: [self pendingActions
		at: regId
		put: pendingUser].
		
	^pendingUser 
	! !

!TLAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/7/2011 10:21'!
addPendingUserAction: aPendingUserAction
	aPendingUserAction confirmationDeadline: (Time deadlineSecs: self confirmationTimeout).
	Lock critical: [self pendingActions 
		at: aPendingUserAction regId
		put: aPendingUserAction ].
! !

!TLAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 07:22'!
addUser: aPendingUser
	self storageAdaptor createUser: aPendingUser asRegisteredUser.! !

!TLAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/7/2011 16:34'!
allUserIds
	^ self storageAdaptor allUserIds 
	! !

!TLAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/7/2011 16:35'!
allUsernames
	^ self storageAdaptor allUsernames
	! !

!TLAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 06:19'!
appName
	^ appName! !

!TLAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 06:19'!
appName: aString
	appName := aString! !

!TLAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/8/2011 02:07'!
confirmAccountChange: regid 
	
	| oldUser newUser pendingChanges|
	self removeExpiredPendingActions.
	Lock critical: [pendingChanges := self pendingActions at: regid ifAbsent: [ ^false ]].
	oldUser := self userForId: pendingChanges  userId.
	newUser := oldUser copy.
	newUser isNil ifFalse: [
		newUser
			email: pendingChanges email;
			username: pendingChanges username;
			encryptedPassword: pendingChanges encryptedPassword;
			applicationProperties: pendingChanges applicationProperties.
		self updateUser: newUser].
	
	Lock critical: [ self pendingActions removeKey: regid ].
	^ true 
	! !

!TLAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 11:31'!
confirmRegistration: regid
	| user |
	self removeExpiredPendingActions.
	Lock critical: [
		user := self pendingActions at: regid ifAbsent: [ ^false ].
		self pendingActions removeKey: regid ].
	self addUser: user.
	^ true 
	! !

!TLAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/7/2011 10:59'!
confirmUserAction: regid
	| action |
	self removeExpiredPendingActions.
	Lock critical: [
		action := self pendingActions at: regid ifAbsent: [ ^false ].
		self pendingActions removeKey: regid ].
	action confirmBlock value: action.
	^ true 
	! !

!TLAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 07:52'!
confirmationTimeout
	confirmationTimeout isNil ifTrue: [ confirmationTimeout := self defaultConfirmationTimeout ].
	^ confirmationTimeout! !

!TLAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 07:52'!
confirmationTimeoutMinutes
	^ ((self confirmationTimeout) / 60) rounded ! !

!TLAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/7/2011 10:07'!
confirmationURL: regId
	^ 'http://' , self loginComponent session requestContext request host, self session baseUrl asString , '?confirm=' , regId.
! !

!TLAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/10/2011 12:05'!
defaultConfirmationTimeout
	^ 60 * loginComponent confirmationTimeout ! !

!TLAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/7/2011 15:54'!
deleteUser: aUser
	(self pendingActions values select:  [ :u | u userId = aUser userId ])
		do: [ :u | self pendingActions removeKey: u regId].
		
	self storageAdaptor deleteUser: aUser! !

!TLAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/7/2011 15:55'!
deleteUserByUsername: aUsername
	| reguser |
	reguser := self userForUsername: aUsername.
	reguser isNil ifFalse: [ self deleteUser: reguser ].
! !

!TLAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 08:10'!
generateRegId
	^ self class generateRegId ! !

!TLAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 05:58'!
getUser: aUsername encryptedPassword: pswd ifAbsent: aBlock

	| user |
	user := self storageAdaptor userForUsername: aUsername.
	user ifNotNilDo: [ :u |
		(user verifyEncryptedPassword: pswd) ifFalse: [ user := nil ]].
	user isNil ifTrue: [ ^ aBlock value ].
	^user
! !

!TLAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/2/2011 21:36'!
getUser: aUsername password: pswd ifAbsent: aBlock

	| user |
	user := self storageAdaptor userForUsername: aUsername.
	user ifNotNilDo: [ :u |
		(user verifyPassword: pswd) ifFalse: [ user := nil ]].
	user isNil ifTrue: [ ^ aBlock value ].
	^user
! !

!TLAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 11:31'!
initialize
	super initialize.
	confirmationTimeout := nil.
! !

!TLAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/10/2011 12:00'!
loginComponent: aLoginComponent
	loginComponent := aLoginComponent ! !

!TLAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/2/2011 21:09'!
loginUser: user encryptedPassword: pswd from: hostAddress
	| reguser |
	reguser := self getUser: user encryptedPassword: pswd ifAbsent: [ nil ].
	reguser isNil
		ifFalse: [
			reguser
				lastLogin: DateAndTime now;
				lastLoginFrom: hostAddress;
				incrementLoginCount.
			self saveUser: reguser.
		
			^ TLUser
				username: user
				userId: (reguser userId)
				email: (reguser email)
				lastLogin: (reguser lastLogin)
				lastLoginFrom: (reguser lastLoginFrom)
				loginCount: (reguser loginCount)
				applicationProperties: (reguser applicationProperties)]
			
		ifTrue: [ ^nil ]
	 ! !

!TLAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/8/2011 09:39'!
loginUser: username password: pswd from: hostAddress
	| reguser |
	reguser := self getUser: username password: pswd ifAbsent: [ nil ].
	reguser isNil ifTrue: [ reguser := self getUser: username encryptedPassword: pswd ifAbsent: [ nil ]].
	reguser isNil
		ifFalse: [
			reguser
				lastLogin: DateAndTime now;
				lastLoginFrom: hostAddress;
				incrementLoginCount.
			self saveUser: reguser.
		
			^ TLUser
				username: (reguser username)
				userId: (reguser userId)
				email: (reguser email)
				lastLogin: (reguser lastLogin)
				lastLoginFrom: (reguser lastLoginFrom)
				loginCount: (reguser loginCount)
				applicationProperties: (reguser applicationProperties)]
			
		ifTrue: [ ^nil ]
	 ! !

!TLAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/7/2011 11:29'!
loginUserById: userId from: hostAddress
	| reguser |
	reguser := self storageAdaptor userForId: userId .
	reguser isNil
		ifFalse: [
			reguser
				lastLogin: DateAndTime now;
				lastLoginFrom: hostAddress;
				incrementLoginCount.
			self saveUser: reguser.
		
			^ TLUser
				username: (reguser username)
				userId: (reguser userId)
				email: (reguser email)
				lastLogin: (reguser lastLogin)
				lastLoginFrom: (reguser lastLoginFrom)
				loginCount: (reguser loginCount)
				applicationProperties: (reguser applicationProperties)]
			
		ifTrue: [ ^nil ]
	 ! !

!TLAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/9/2011 11:54'!
pendingActions
	"Answer the pending actions list for our appName."

	^ PendingActions at: self appName ifAbsentPut: [ Dictionary new ]! !

!TLAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 13:25'!
pendingActions: aDictionary
	"Answer the pending actions list for our appName."
	PendingActions at: self appName put: aDictionary ! !

!TLAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 07:19'!
registeredUserFor: aUser
	^ self userForId: aUser userId! !

!TLAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 13:23'!
removeExpiredPendingActions

	Lock critical: [
		self pendingActions: (self pendingActions select: [ :v | v isValid ])]
! !

!TLAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/2/2011 20:47'!
reset: regId password: pswd
	| oldUser newUser |
	
	self removeExpiredPendingActions.
	
	oldUser := self userForUsername: (self pendingActions at: regId) username.
	newUser := oldUser copy; password: pswd.
	
	self loginComponent authenticationManager updateUser: newUser.
	
	self pendingActions removeKey: regId.
	^ true 
	! !

!TLAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 06:02'!
saveUser: user
	self storageAdaptor updateUser: user.! !

!TLAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/2/2011 21:11'!
storageAdaptor
	storageAdaptor isNil ifTrue: [ self storageAdaptor: (TLFileStorageAdaptor name: self appName)].
	^storageAdaptor 
! !

!TLAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 06:02'!
storageAdaptor: aStorageAdaptor
	storageAdaptor := aStorageAdaptor.
! !

!TLAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 06:03'!
updateUser: user
	self storageAdaptor updateUser: user! !

!TLAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 06:03'!
userForId: aUserId
	^ self storageAdaptor userForId: aUserId! !

!TLAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 11:33'!
userForPasswordReset: regid
	| retval |
	self removeExpiredPendingActions.
	Lock critical: [ retval := self pendingActions removeKey: regid ifAbsent: [ nil ]].
	^ retval
	! !

!TLAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 06:03'!
userForUsername: username
	^ self storageAdaptor userForUsername: username! !

!TLAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 06:04'!
usernameExists: uname
	^ self storageAdaptor usernameExists: uname! !

!TLAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/7/2011 15:50'!
usernameIsPending: uname

	| retval |
	Lock critical: [ retval := self pendingActions values anySatisfy: [ :u | u username = uname]].
	^retval! !

!TLAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 06:04'!
usersForEmail: email
	^ self storageAdaptor usersForEmail: email.
! !

!TLAuthenticationManager methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/1/2011 06:04'!
verifyPassword: pswd for: user
	^(self userForId: user userId) verifyPassword: pswd! !

Object subclass: #TLMultiFileDatabase
	instanceVariableNames: 'storageDirectoryName maxEntryCount matchBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TF-Login'!

!TLMultiFileDatabase commentStamp: '<historical>' prior: 0!
I am a file-based database. Objects are saved in named files and retrieved by the storage name when needed. Multiple versions of the object storage files are maintained. A hack for mutli-indexing is provided in the form of a "match block" specified by the user that is used to wildcard the object storage name to only include the portion of the name that comprises the primary key. The filename can then contain other information that may be useful for finding a desired object. This allows the OS file system to be used to select files.

Versioning is accomplished by suffixing the filenames with a dot followed by the version number.

Example: The objects to be stored have a primary key value and another value that is frequently used for retrieval that is unique but can change over the life of the object. Name the objects with a string like primarykey-secondarykey. Wildcarding can then be used to retrieve by either primary or secondary key: primarykey-*.* or *-secondarykey.*. The match block returns the primary key wildcard string, which allows the MultiFileDatabase instance to properly trim and delete files whose secondary key may have changed.

There is no locking. Synchronization is expected to be done by the sender.

!

!TLMultiFileDatabase class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/31/2010 15:14'!
on: aDirectoryName
	^ (self new)
		storageDirectoryName: aDirectoryName;
		yourself! !

!TLMultiFileDatabase methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/4/2011 13:18'!
defaultMaxEntryCount
    ^ 2! !

!TLMultiFileDatabase methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/31/2010 15:08'!
deleteDatabase
	| entries |
	entries := self storageDirectory entries.
	entries do: [ :entry | self storageDirectory deleteFileNamed: entry name ].
	self storageDirectory deleteDirectory: (self storageDirectory fullName).! !

!TLMultiFileDatabase methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/31/2010 18:25'!
deleteFilesNamed: aString
	| filenames |
	filenames := self storageDirectory fileNamesMatching: (self matchBlock value: aString).
	filenames do: [ :each | self storageDirectory deleteFileNamed: each ].
! !

!TLMultiFileDatabase methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/31/2010 15:00'!
lastEntryNamed: aString
    | lastEntry |
    lastEntry := self lastSavedFileNamed: aString.
    lastEntry ifNil: [ ^ nil ].
    ^ ReferenceStream
        readOnlyFileNamed: (self storageDirectory fullNameFor: lastEntry)
        do: [ :f | f next ]! !

!TLMultiFileDatabase methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/31/2010 18:25'!
lastSavedFileNamed: aString
   ^ (self storageDirectory fileNamesMatching: (self matchBlock value: aString))
        detectMax: [:each |  self versionFor: each ]! !

!TLMultiFileDatabase methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/31/2010 18:26'!
matchBlock
	^ matchBlock ifNil: [[ :fileName | fileName,'.*']]! !

!TLMultiFileDatabase methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/31/2010 18:26'!
matchBlock: aOneArgBlock
	matchBlock := aOneArgBlock! !

!TLMultiFileDatabase methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/31/2010 15:03'!
maxEntryCount
	^ maxEntryCount ifNil: [ self defaultMaxEntryCount ]! !

!TLMultiFileDatabase methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/31/2010 15:04'!
maxEntryCount: anInteger
	maxEntryCount := anInteger
! !

!TLMultiFileDatabase methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/9/2011 12:43'!
restoreObjectNamed: aString

     ^ self lastEntryNamed: aString
     ! !

!TLMultiFileDatabase methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/4/2011 13:16'!
saveObject: anObject withName: aString
   | version |
        version := (self lastSavedFileNamed: aString) isNil
            ifTrue: [ 1 ]
            ifFalse: [ (self versionFor: (self lastSavedFileNamed: aString)) + 1 ].
        ReferenceStream
            newFileNamed: (self storageDirectory fullPathFor: aString ) , '.' , version asString
            do: [ :f | f nextPut: anObject; flush ].
        self trimFilesNamed: aString! !

!TLMultiFileDatabase methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/31/2010 14:48'!
storageDirectory
    ^ (FileDirectory default directoryNamed: self storageDirectoryName) assureExistence.! !

!TLMultiFileDatabase methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/31/2010 14:49'!
storageDirectoryName
	^ storageDirectoryName ifNil: [ storageDirectoryName := self name ].
! !

!TLMultiFileDatabase methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/31/2010 14:49'!
storageDirectoryName: aName
	storageDirectoryName := aName
! !

!TLMultiFileDatabase methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/9/2011 12:43'!
trimFilesNamed: aString

    | filenames versionsToKeep |

    versionsToKeep := self maxEntryCount.
    filenames := self storageDirectory fileNamesMatching: (self matchBlock value: aString).
    filenames size < versionsToKeep ifTrue: [ ^ self ].
  
    ((filenames sortBy: [ :a :b | (self versionFor: a) < (self versionFor: b) ])
        allButLast: versionsToKeep)
            do: [ :each |
			self storageDirectory deleteFileNamed:  each ]! !

!TLMultiFileDatabase methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/31/2010 14:55'!
versionFor: aFileName
	^ ((aFileName trimBoth: [ :c | c = $' ])  allButFirst: (aFileName lastIndexOf: $.)) asInteger! !

Object subclass: #TLReadWrite
	instanceVariableNames: 'monitor readerCount busy preferWriters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TF-Login'!

!TLReadWrite commentStamp: '<historical>' prior: 0!
I provide many-reader single-writer access synchronization for a resource.

If preferWriters is true, writers will be serviced in preference to readers. Otherwise, readers will be serviced in preference to writers. Note that the difference is only interesting when there is significant contention for thr shared resource.!

!TLReadWrite class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/9/2011 12:50'!
new
	^ self basicNew initialize.! !

!TLReadWrite class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/4/2011 10:24'!
preferWriters: aBoolean
	^  (self new)
		preferWriters: aBoolean;
		yourself! !

!TLReadWrite methodsFor: 'private' stamp: 'TonyFleig 1/9/2011 12:08'!
endExclusiveWrite
	monitor critical: [
		busy := false.
		
		self preferWriters
			ifTrue: [
				(monitor queueFor: #OkToWrite)  isEmpty
					ifTrue: [ monitor signalAll: #OkToRead]
					ifFalse: [ monitor signalAll: #OkToWrite]]
			ifFalse: [
				(monitor queueFor: #OkToRead)  isEmpty not
					ifTrue: [ monitor signalAll: #OkToRead]
					ifFalse: [ monitor signalAll: #OkToWrite]]]
				! !

!TLReadWrite methodsFor: 'private' stamp: 'TonyFleig 1/4/2011 11:44'!
endSharedRead
	monitor critical: [
		readerCount := readerCount - 1.
		readerCount = 0 ifTrue: [ monitor signalAll: #OkToWrite ]]
! !

!TLReadWrite methodsFor: 'public' stamp: 'TonyFleig 1/4/2011 11:21'!
exclusiveWrite: aBlock
	[
		self startExclusiveWrite.
		aBlock value]
	 ensure: [self endExclusiveWrite]
	! !

!TLReadWrite methodsFor: 'initialization' stamp: 'TonyFleig 1/4/2011 09:45'!
initialize
	monitor := Monitor new.
	readerCount := 0.
	busy := false! !

!TLReadWrite methodsFor: 'private' stamp: 'TonyFleig 1/4/2011 10:20'!
preferWriters
	^ preferWriters ifNil: [ false ]! !

!TLReadWrite methodsFor: 'public' stamp: 'TonyFleig 1/4/2011 10:21'!
preferWriters: aBoolean
	"Stall readers if any writers are waiting."
	preferWriters := aBoolean! !

!TLReadWrite methodsFor: 'public' stamp: 'TonyFleig 1/4/2011 11:21'!
sharedRead: aBlock
	[
		self startSharedRead.
		aBlock value] ensure: [ self endSharedRead ]
! !

!TLReadWrite methodsFor: 'private' stamp: 'TonyFleig 1/4/2011 11:44'!
startExclusiveWrite
	monitor critical: [
		monitor waitWhile: [ busy or: [ readerCount > 0] ] for: #OkToWrite.
		busy := true]
! !

!TLReadWrite methodsFor: 'private' stamp: 'TonyFleig 1/9/2011 12:08'!
startSharedRead
	monitor critical: [
		self preferWriters
			ifTrue: [
				monitor waitWhile: [ busy or: [(monitor queueFor: #OkToWrite) isEmpty not]] for: #OkToRead]
			ifFalse: [
				monitor waitWhile: [ busy ] for: #OkToRead].
		readerCount := readerCount + 1]
! !

Object subclass: #TLStorageAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TF-Login'!

TLStorageAdaptor subclass: #TLFileStorageAdaptor
	instanceVariableNames: 'db appName rw'
	classVariableNames: 'StorageAdaptorsByName'
	poolDictionaries: ''
	category: 'TF-Login'!

!TLFileStorageAdaptor class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/4/2011 13:03'!
initialize
	"Force re-instantiation of all storage adaptor instances. Evaluate this if you have
	leftover storage adapters (perhaps from re-naming an app) that you want to remove."
	"TLFileStorageAdaptor initialize"
	
	StorageAdaptorsByName := nil.! !

!TLFileStorageAdaptor class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/4/2011 12:25'!
name: aString
	^ (StorageAdaptorsByName ifNil: [ StorageAdaptorsByName := Dictionary new])
		at: aString ifAbsent: [
			StorageAdaptorsByName at: aString put: ((self basicNew)
				initialize: aString;
				yourself)] 
		! !

!TLFileStorageAdaptor class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/4/2011 12:11'!
new
	self shouldNotImplement ! !

!TLFileStorageAdaptor methodsFor: 'public' stamp: 'TonyFleig 1/7/2011 16:26'!
allUserIds
	rw sharedRead: [
		^ (db storageDirectory fileNames collect: [ :each |
			(self userIdPart: each)]) asSet]! !

!TLFileStorageAdaptor methodsFor: 'public' stamp: 'TonyFleig 1/7/2011 16:37'!
allUsernames
rw sharedRead: [
		^ (db storageDirectory fileNames collect: [ :each |
			(self userIdPart: each)]) asSet inject: Set new into: [ :result :userId |
				| user |
				result
					add: (user := self userForIdUnsynchronized: userId) username;
					yourself ]]
	! !

!TLFileStorageAdaptor methodsFor: 'private' stamp: 'TonyFleig 12/30/2010 11:57'!
appName
	^ appName ifNil: [ ^ 'LoginUserDatabase']! !

!TLFileStorageAdaptor methodsFor: 'private' stamp: 'TonyFleig 12/30/2010 11:57'!
appName: aString
	appName := aString! !

!TLFileStorageAdaptor methodsFor: 'private' stamp: 'TonyFleig 12/31/2010 16:25'!
baseFileNameFor: aFileName
	^ aFileName allButLast: (aFileName size) - (aFileName lastIndexOf: $.) + 1! !

!TLFileStorageAdaptor methodsFor: 'public' stamp: 'TonyFleig 1/5/2011 12:13'!
createUser: aUser
	rw exclusiveWrite: [self saveUser: aUser]! !

!TLFileStorageAdaptor methodsFor: 'test-support' stamp: 'TonyFleig 12/31/2010 13:38'!
deleteDatabase
	db deleteDatabase.! !

!TLFileStorageAdaptor methodsFor: 'public' stamp: 'TonyFleig 1/4/2011 12:40'!
deleteUser: aUser
	rw exclusiveWrite: [
		db deleteFilesNamed: (self key: aUser)]! !

!TLFileStorageAdaptor methodsFor: 'private' stamp: 'TonyFleig 1/4/2011 20:02'!
encodeUsername: aUsername

	^ (Base64MimeConverter  mimeEncode: aUsername asLowercase readStream) contents trimRight: [ :c | c = $=]! !

!TLFileStorageAdaptor methodsFor: 'test-support' stamp: 'TonyFleig 12/31/2010 13:44'!
fileCount
	^ db storageDirectory entries size! !

!TLFileStorageAdaptor methodsFor: 'private' stamp: 'TonyFleig 1/9/2011 11:53'!
initialize: anAppName
	"Set appName before invoking this."
	self initialize.
	self appName: anAppName.
	rw := TLReadWrite preferWriters: true.
	db := TLMultiFileDatabase on: (self appName, 'UserDb').
	db matchBlock: [ :aString |
		'*-',(aString allButFirst: (aString lastIndexOf: $-)), '.*'].! !

!TLFileStorageAdaptor methodsFor: 'private' stamp: 'TonyFleig 1/5/2011 12:11'!
key: aUser
	^ (self encodeUsername: aUser username), '-', aUser userId.! !

!TLFileStorageAdaptor methodsFor: 'private' stamp: 'TonyFleig 1/5/2011 12:12'!
keyForUsername: uname
	^ self key: (self userForUsername: uname) .! !

!TLFileStorageAdaptor methodsFor: 'private' stamp: 'TonyFleig 12/31/2010 17:43'!
maxVersions: anInteger
	db maxEntryCount: anInteger! !

!TLFileStorageAdaptor methodsFor: 'private' stamp: 'TonyFleig 1/4/2011 12:40'!
saveUser: aUser
	db saveObject: aUser withName: (self key: aUser) ! !

!TLFileStorageAdaptor methodsFor: 'public' stamp: 'TonyFleig 1/9/2011 12:41'!
updateUser: aUser

	rw exclusiveWrite: [
		self saveUser: aUser]! !

!TLFileStorageAdaptor methodsFor: 'public' stamp: 'TonyFleig 1/4/2011 11:42'!
userForId: aUserId

	rw sharedRead: [ ^ self userForIdUnsynchronized: aUserId ].! !

!TLFileStorageAdaptor methodsFor: 'public' stamp: 'TonyFleig 1/5/2011 09:30'!
userForIdUnsynchronized: aUserId

	(db storageDirectory fileNamesMatching: '*-', aUserId,'.*')
		do: [ :each |
			(self userIdPart: each) = aUserId
				ifTrue: [
					| user |
					"It is remotely possible that on case-insensitive filesystems (Windows, OS X), there could be multiple matches,
					so we need to check the actual user object to be absolutely sure we have the right user."
					user := db restoreObjectNamed: (self baseFileNameFor: each).
					user userId = aUserId ifTrue: [^ user ]]].
	^  nil! !

!TLFileStorageAdaptor methodsFor: 'public' stamp: 'TonyFleig 1/5/2011 10:48'!
userForUsername: username
	| encUsername |
	encUsername := self encodeUsername: username.
	rw
		sharedRead: [ 
			(db storageDirectory fileNamesMatching: encUsername , '-*')
				do: [ :each | 
					(self usernamePart: each) = encUsername
						ifTrue: [ 
							| user |
							"It is remotely possible that on case-insensitive filesystems (Windows, OS X), there could be multiple matches,
							so we need to check the actual user object to be absolutely sure we have the right user."
							user := db restoreObjectNamed: (self baseFileNameFor: each).
							user username asLowercase = username asLowercase
								ifTrue: [ ^ user ] ] ] ].
	^ nil! !

!TLFileStorageAdaptor methodsFor: 'private' stamp: 'TonyFleig 1/4/2011 12:54'!
userIdPart: aFileName
	^ (aFileName allButFirst: (aFileName lastIndexOf: $-)) copyUpToLast: $.! !

!TLFileStorageAdaptor methodsFor: 'public' stamp: 'TonyFleig 1/2/2011 06:43'!
usernameExists: username
	^ (self userForUsername: username) notNil ! !

!TLFileStorageAdaptor methodsFor: 'public' stamp: 'TonyFleig 1/5/2011 09:27'!
usernamePart: aFilename
	^ aFilename allButLast: aFilename size - (aFilename lastIndexOf: $-) + 1! !

!TLFileStorageAdaptor methodsFor: 'public' stamp: 'TonyFleig 1/9/2011 07:38'!
usersForEmail: email
	rw sharedRead: [
		^ (db storageDirectory fileNames collect: [ :each |
			(self userIdPart: each)]) asSet inject: Set new into: [ :result :userId |
				| user |
				(user := self userForIdUnsynchronized: userId) email asLowercase = email asLowercase 
					ifTrue: [ result add: user ]. result ]]
	! !

!TLStorageAdaptor methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/7/2011 18:44'!
allUserIds
	"Answer a collection of all registered user IDs."
	self subclassResponsibility ! !

!TLStorageAdaptor methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/2/2011 06:51'!
createUser: aUser
	"Add the specified user uniquely identified by RegisteredUser>>#userId If the user already exists, update the user."

	self subclassResponsibility ! !

!TLStorageAdaptor methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/2/2011 06:51'!
deleteUser: aUser
	"Remove the specified user uniquely identified by RegisteredUser>>#userId If the user does not exist, ignore."
	
	self subclassResponsibility ! !

!TLStorageAdaptor methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/2/2011 06:51'!
updateUser: aUser
	"Update the specified user uniquely identified by RegisteredUser>>#userId. If the user does not exist, create it."
	self subclassResponsibility ! !

!TLStorageAdaptor methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/9/2011 07:40'!
userForId: aUserId
	"Answer the RegisteredUser identified by aUserId. Note that user ID matching
	should be case-sensitive."
	self subclassResponsibility ! !

!TLStorageAdaptor methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/9/2011 07:39'!
userForUsername: username
	"Answer the user with the specified username. Note that usernames may change but duplicates are not allowed.
	Not also that username matching should be case-blind."
	self subclassResponsibility ! !

!TLStorageAdaptor methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/9/2011 07:40'!
usernameExists: username
	"Answer true if a user with the specified username is present. Otherwise answer false.
	Note that username matching should be case-blind."
	self subclassResponsibility ! !

!TLStorageAdaptor methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/9/2011 07:39'!
usersForEmail: email
	"Answer the collection of users with the specified email address.
	Note that email address matching should be case-blind."
	self subclassResponsibility ! !

Object subclass: #TLTestAppLoginHistoryItem
	instanceVariableNames: 'dateTime location'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TF-Login'!

!TLTestAppLoginHistoryItem class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/16/2010 08:14'!
when: aDateAndTime where: aLocationString
	^ self new
		dateTime: aDateAndTime;
		location: aLocationString;
		yourself! !

!TLTestAppLoginHistoryItem methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/28/2010 14:32'!
asString
	^ self dateTimeFormatted, ' from ', self location ! !

!TLTestAppLoginHistoryItem methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/16/2010 08:10'!
dateTime
	^ dateTime
	! !

!TLTestAppLoginHistoryItem methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/16/2010 08:10'!
dateTime: aDateAndTime
	dateTime := aDateAndTime 
	! !

!TLTestAppLoginHistoryItem methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/16/2010 08:43'!
dateTimeFormatted
	| string |
	
	string := dateTime asString at: 11 put: $ ; yourself.
	^ string allButLast: 6! !

!TLTestAppLoginHistoryItem methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/16/2010 08:11'!
location
	^ location
	! !

!TLTestAppLoginHistoryItem methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/16/2010 08:11'!
location: aString
	location := aString
	! !

Object subclass: #TLUser
	instanceVariableNames: 'userId lastLogin lastLoginFrom username email loginCount applicationProperties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TF-Login'!

TLUser class
	instanceVariableNames: 'userIdGenerator'!

TLUser class
	instanceVariableNames: 'userIdGenerator'!

TLUser subclass: #TLRegisteredUser
	instanceVariableNames: 'encpswd'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TF-Login'!

TLRegisteredUser subclass: #TLPendingUser
	instanceVariableNames: 'confirmationDeadline regId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TF-Login'!

TLPendingUser subclass: #TLPendingAcountChange
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TF-Login'!

!TLPendingAcountChange class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/3/2011 07:52'!
fromUser: aUser regId: regId confirmationDeadline: deadline
	^ (self basicNew)
		initialize; 
		email: aUser email;
		applicationProperties: aUser applicationProperties;
		regId: regId;
		username: aUser username;
		encryptedPassword: aUser encryptedPassword;
		userId: aUser userId;
		confirmationDeadline: deadline;
		yourself.! !

!TLPendingAcountChange methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/3/2011 07:50'!
asRegisteredUser
	^ (TLRegisteredUser username: self username encpswd: self encryptedPassword email: self email)
		lastLogin: self lastLogin;
		lastLoginFrom: self lastLoginFrom;
		applicationProperties: self applicationProperties;
		yourself
		! !

TLPendingUser subclass: #TLPendingPasswordReset
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TF-Login'!

!TLPendingPasswordReset class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/9/2010 15:46'!
username: uname regId: regId confirmationDeadline: deadline
	^ (self basicNew)
		initialize;
		username: uname;
		regId: regId;
		confirmationDeadline: deadline;
		yourself! !

!TLPendingUser class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/28/2010 18:22'!
username: uname password: pswd email: em regId: regId confirmationDeadline: deadline
	^ (self basicNew)
		initialize;
		username: uname;
		password: pswd;
		email: em;
		regId: regId;
		confirmationDeadline: deadline;
		yourself! !

!TLPendingUser methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/3/2011 12:11'!
asRegisteredUser 
	^ (TLRegisteredUser
		username: (self username)
		encpswd: (self encryptedPassword)
		email: (self email))
		userId: (self userId);
		applicationProperties: self applicationProperties;
		yourself! !

!TLPendingUser methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/24/2010 10:28'!
confirmationDeadline
	^ confirmationDeadline ! !

!TLPendingUser methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/24/2010 10:28'!
confirmationDeadline: aTime
	confirmationDeadline := aTime! !

!TLPendingUser methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/25/2010 08:40'!
isValid
	^ confirmationDeadline > Time millisecondClockValue ! !

!TLPendingUser methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/25/2010 09:02'!
lastLogin
	self shouldNotImplement ! !

!TLPendingUser methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/25/2010 09:07'!
lastLogin: aDateAndTime
	self shouldNotImplement ! !

!TLPendingUser methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/25/2010 09:07'!
lastLoginFrom
	self shouldNotImplement ! !

!TLPendingUser methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/25/2010 09:07'!
lastLoginFrom: aHostAddress
	self shouldNotImplement ! !

!TLPendingUser methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/25/2010 09:08'!
loginCount
	self shouldNotImplement ! !

!TLPendingUser methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/25/2010 09:08'!
loginCount: n
	self shouldNotImplement ! !

!TLPendingUser methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/28/2010 18:19'!
regId
	^ regId! !

!TLPendingUser methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/28/2010 18:19'!
regId: anId
	regId := anId! !

TLPendingUser subclass: #TLPendingUserAction
	instanceVariableNames: 'callbackBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TF-Login'!

!TLPendingUserAction class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/7/2011 11:10'!
forUser: aUser onConfirmDo: aOneArgBlock
	^ (self basicNew)
		initialize;
		onConfirmDo: aOneArgBlock;
		email: aUser email;
		applicationProperties: aUser applicationProperties;
		username: aUser username;
		userId: aUser userId;
		yourself.! !

!TLPendingUserAction methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/7/2011 11:05'!
confirmBlock
	^ callbackBlock ifNil: [ [ :arg | ] ]! !

!TLPendingUserAction methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/7/2011 10:59'!
onConfirmDo: aOneArgBlock
	" A block to be invoked when the user has responded to the confirmation email.
	The argument is the pendingUserAction."
	callbackBlock := aOneArgBlock ! !

!TLRegisteredUser class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/3/2011 07:52'!
username: uname encpswd: pswd email: em
	^ (self basicNew)
		initialize;
		username: uname;
		encryptedPassword: pswd;
		email: em;
		yourself ! !

!TLRegisteredUser class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/26/2010 12:49'!
username: uname password: pswd email: em
	^ (self basicNew)
		initialize;
		username: uname;
		password: pswd;
		email: em;
		yourself ! !

!TLRegisteredUser methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/29/2010 15:11'!
encryptPassword: aPassword
	^ (Base64MimeConverter mimeEncode: (ReadStream on: (SHA1 hashMessage: aPassword,userId))) contents.
! !

!TLRegisteredUser methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/31/2010 10:46'!
encryptedPassword
	^ encpswd
	! !

!TLRegisteredUser methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/3/2011 07:52'!
encryptedPassword: aString
	encpswd := aString! !

!TLRegisteredUser methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/25/2010 08:20'!
incrementLoginCount
	loginCount := loginCount + 1! !

!TLRegisteredUser methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/31/2010 10:29'!
password: aString
	encpswd := self encryptPassword: aString! !

!TLRegisteredUser methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/16/2010 13:34'!
updateFromUser: aUser
	self username: aUser username.
	self lastLogin:aUser lastLogin.
	self lastLoginFrom: aUser lastLoginFrom.
	self loginCount: aUser loginCount.
	self email: aUser email.
	self applicationProperties: aUser applicationProperties.! !

!TLRegisteredUser methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/31/2010 10:41'!
verifyEncryptedPassword: aPassword
	^ aPassword = encpswd! !

!TLRegisteredUser methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/31/2010 10:41'!
verifyPassword: aPassword
	^ self verifyEncryptedPassword: (self encryptPassword: aPassword)
! !

!TLUser class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/2/2011 21:02'!
defaultUserIdGenerator
	^ [ TLAuthenticationManager generateRegId ]! !

!TLUser class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/26/2010 08:20'!
new
	self shouldNotImplement   ! !

!TLUser class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/26/2010 12:41'!
newUserId
	^ self userIdGenerator value ! !

!TLUser class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/26/2010 12:38'!
userIdGenerator
	^ userIdGenerator ifNil: [ self defaultUserIdGenerator ]! !

!TLUser class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/26/2010 12:40'!
userIdGenerator: aNoArgBlock
	userIdGenerator := aNoArgBlock ! !

!TLUser class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/26/2010 14:52'!
username: user email: em lastLogin: ll lastLoginFrom: llf loginCount: lc

	"This method should only be invoked by the unit tests."

	^ (self basicNew)
		initialize;
		username: user;
		email: em;
		lastLogin: ll;
		lastLoginFrom: llf;
		loginCount: lc; 
		yourself! !

!TLUser class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/26/2010 14:51'!
username: user userId: id email: em lastLogin: ll lastLoginFrom: llf loginCount: lc applicationProperties: aDictionary

	"This method should only be invoked by the RegisteredUsers class."

	^ (self basicNew)
		initialize;
		username: user;
		userId: id;
		email: em;
		lastLogin: ll;
		lastLoginFrom: llf;
		loginCount: lc; 
		applicationProperties: aDictionary;
		yourself! !

!TLUser methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/16/2010 08:04'!
applicationProperties
	^ applicationProperties ifNil: [ applicationProperties := Dictionary new ]! !

!TLUser methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/16/2010 09:08'!
applicationProperties: aDictionary

	applicationProperties := aDictionary! !

!TLUser methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/24/2010 11:11'!
email
	^ email! !

!TLUser methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/24/2010 11:11'!
email: aString
	email := aString! !

!TLUser methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/26/2010 12:48'!
initialize
	super initialize.
	loginCount := 0.
	userId := self class newUserId.
! !

!TLUser methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/7/2011 17:01'!
lastLogin
	^ lastLogin ifNil: [ DateAndTime epoch ]! !

!TLUser methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/24/2010 11:11'!
lastLogin: aDateAndTime
	lastLogin := aDateAndTime ! !

!TLUser methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/9/2011 11:54'!
lastLoginFormatted
	| stream |
	stream := WriteStream on: String new.
	stream nextPutAll: 'on '.
	self lastLogin printYMDOn: stream.
	stream nextPutAll: ' at '.
	self lastLogin printHMSOn: stream.
	stream
		nextPutAll: ' ';
		nextPutAll: self lastLogin timeZoneAbbreviation.
	^ stream contents! !

!TLUser methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/7/2011 17:22'!
lastLoginFrom
	^ lastLoginFrom ifNil: ['']! !

!TLUser methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/24/2010 11:11'!
lastLoginFrom: aHostAddress
	lastLoginFrom  := aHostAddress! !

!TLUser methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/24/2010 11:38'!
loginCount
	^loginCount! !

!TLUser methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/24/2010 11:41'!
loginCount: n
	loginCount := n! !

!TLUser methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/26/2010 12:44'!
userId
	^ userId! !

!TLUser methodsFor: 'as yet unclassified' stamp: 'TonyFleig 12/26/2010 12:43'!
userId: anId
	userId := anId! !

!TLUser methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/24/2010 11:11'!
username
	^ username! !

!TLUser methodsFor: 'as yet unclassified' stamp: 'TonyFleig 11/24/2010 11:11'!
username: aString
	username := aString! !

Object subclass: #UpdateMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TF-Login'!

!UpdateMessage class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/9/2011 14:36'!
initialize

	| ws |
	ws := (Workspace openContents: self messageText)
		label: 'IMPORTANT'.
	ws topView
		position: 100@100;
		extent: 600@300! !

!UpdateMessage class methodsFor: 'as yet unclassified' stamp: 'TonyFleig 1/9/2011 14:44'!
messageText

	^ 
'If you are upgrading from a version of TFLogin eartlier than 157 (2011-01-09 19:20:01), then read the following:

The shape of the User objects changed as a result of removing unused variables, so YOU WILL HAVE TO DELETE YOUR USER DATABASE AFTER INSTALLING THIS UPDATE.

Evaluate statements like these to do this.

     TLAuthenticationManager initialize.
     (TLFileStorageAdaptor name: ''LoginTestApp'') deleteDatabase.

(Substitute your app-name for LoginTestApp above.)

I offer my apologies for any problems this may cause you. I hope this will be the last time something like this is necessary.'! !
TLLoginComponentBase initialize!
TLTestApp initialize!
TLTester initialize!
TLConfiguration initialize!
TLTestAppConfiguration initialize!
TLAuthenticationManager initialize!
TLFileStorageAdaptor initialize!
UpdateMessage initialize!
